(******************************************************************************)
(* Copyright (c) 1988 by GMD Karlruhe, Germany				      *)
(* Gesellschaft fuer Mathematik und Datenverarbeitung			      *)
(* (German National Research Center for Computer Science)		      *)
(* Forschungsstelle fuer Programmstrukturen an Universitaet Karlsruhe	      *)
(* All rights reserved.							      *)
(******************************************************************************)

IMPLEMENTATION MODULE FdSet;

  PROCEDURE FD_SET(fd: SIGNED; VAR set: FdSet);
	VAR i: SIGNED;
	    bits: BITSET;
  BEGIN
	i := fd DIV NFDBITS;
	bits := {}; INCL(bits,fd MOD NFDBITS);
	set[i] := set[i] + bits;
  END FD_SET;

  PROCEDURE FD_CLR(fd: SIGNED; VAR set: FdSet);
	VAR i: SIGNED;
	    bits: BITSET;
  BEGIN
	i := fd DIV NFDBITS;
	bits := {}; INCL(bits, fd MOD NFDBITS);
	set[i] := set[i] - bits;
  END FD_CLR;

  PROCEDURE FD_ZERO(VAR set: FdSet);
	VAR i: SIGNED;
  BEGIN
	FOR i := 0 TO 7 DO
		set[i]:={};
	END;
  END FD_ZERO;

  PROCEDURE FD_ISSET(fd: SIGNED; VAR set: FdSet): BOOLEAN;
	VAR i: SIGNED;
	    bits: BITSET;
  BEGIN
	i := fd DIV NFDBITS;
	bits := {}; INCL(bits, fd MOD NFDBITS);
	RETURN (set[i]*bits)#{};
  END FD_ISSET;

END FdSet.
