IMPLEMENTATION MODULE Lib;

FROM SYSTEM IMPORT ADDRESS, BYTE;
FROM RealMath IMPORT ln, sqrt, cos, pi;
IMPORT ProgEnv;

CONST PI=3.1415926535897932385;
VAR rnd:LONGREAL;

PROCEDURE Fill(buf: ADDRESS; len: CARDINAL; byte: CHAR);
VAR i:CARDINAL;
    p:POINTER TO ARRAY[0..0FFFFFFFH] OF CHAR;
BEGIN
  IF len>0 THEN
    p:=buf;
    FOR i:=0 TO len-1 DO p^[i]:=byte END;
  END;  
END Fill;

PROCEDURE Move(from, to: ADDRESS; len:CARDINAL);
VAR i:CARDINAL;
    f,t:POINTER TO ARRAY[0..65536] OF BYTE;
BEGIN
  IF len>0 THEN
    f:=from;
    t:=to;
    FOR i:=0 TO len-1 DO t^[i]:=f^[i] END;
  END;  
END Move;

PROCEDURE NextArg(VAR s:ARRAY OF CHAR);
BEGIN
  ProgEnv.GetArg(argc, s);
  INC(argc);  
END NextArg;

PROCEDURE ArgN(n:CARDINAL; VAR s:ARRAY OF CHAR); 
BEGIN
  IF n>0 THEN DEC(n) END;
  ProgEnv.GetArg(n, s);
END ArgN;


PROCEDURE Randomize(start:LONGREAL);
BEGIN
  rnd:=start;
  WHILE ABS(rnd)>=1.0 DO rnd:=rnd*(PI-3.0) END;
  IF rnd<0.0 THEN rnd:=rnd+1.0 END;
END Randomize;

PROCEDURE Random():LONGREAL;
BEGIN
  rnd:=rnd + PI;
  rnd:=rnd*rnd;
  rnd:=rnd*rnd;
  rnd:=rnd*rnd;
  rnd:=rnd - LFLOAT(TRUNC(rnd));
  RETURN rnd
END Random;

PROCEDURE Noise12():REAL;
VAR i:CARDINAL;
    r:REAL;
BEGIN
  r:=0.0;
  FOR i:=0 TO 11 DO r:=r + VAL(REAL, Random()) END;
  RETURN r/12.0
END Noise12;

PROCEDURE NoiseGauss():REAL;
VAR u:REAL;
BEGIN
  REPEAT u:=VAL(REAL, Random()) UNTIL u>0.0;
  RETURN sqrt(-2.0*ln(u)) * cos((2.0*PI)*VAL(REAL, Random()))
END NoiseGauss;

(*
PROCEDURE Random():REAL;
VAR g:CARDINAL;
    r:REAL;

  PROCEDURE FRAC(x:REAL):REAL;
  BEGIN RETURN x - FLOAT(TRUNC(x)) END FRAC;

  PROCEDURE Quad(VAR g:CARDINAL; VAR r:REAL);
  VAR gr:REAL;
  BEGIN
    gr:=FLOAT(2*g)*r;
    r:=r*r + FRAC(gr);
    g:=(g*g) + VAL(CARDINAL, TRUNC(r) + TRUNC(gr));
    r:=FRAC(r);
  END Quad;
    
BEGIN
  r:=rnd + FRACPI;
  g:=3 + TRUNC(r);
  r:=FRAC(r);
  Quad(g,r);
  Quad(g,r);
  rnd:=FRAC(r*r + FRAC(FLOAT(2*g)*r));
  RETURN rnd
END Random;
*)

BEGIN
  argc:=0;
  rnd:=0.0;
END Lib.