<*+M2EXTENSIONS *>
<*-CHECKDIV *>
<*-CHECKRANGE *>
<*-COVERFLOW *>
<*-IOVERFLOW*>
<*-PROCINLINE*>
<*+NOPTRALIAS*>
<*-GENHISTORY*>
<*-CHECKNIL *>
<*-GENDEBUG*>
<*-LINENO*>
<*-CHECKINDEX*>
<*-CHECKSET*>
<*CPU="PENTIUM"*>

IMPLEMENTATION MODULE aprspos; (* get aprs position by OE5DXL *)

FROM SYSTEM IMPORT CAST, SHIFT, ADR, CARD8, FILL;

FROM LongMath IMPORT arccos,cos,sin,arctan,tan,round;


PROCEDURE rad(w:REAL):REAL;
BEGIN RETURN w*(PI2/360.0) END rad;


PROCEDURE posvalid(pos-:POSITION):BOOLEAN;
BEGIN RETURN (pos.lat<>0.0) OR (pos.long<>0.0) END posvalid;

PROCEDURE distance(home,dist:POSITION):REAL;
CONST EARTH=40024.0/PI2;
VAR h:LONGREAL;
BEGIN
(*
IO.WrStr(" pyth="); 
IO.WrFixed(EARTH*sqrt(sqr(home.lat-dist.lat)+sqr((dist.long-home.long)*cos(home.lat))), 1,5); 
*)
  h:=ABS(dist.long-home.long);
  IF (h=0.0) & (dist.lat=home.lat) THEN RETURN 0.0
  ELSE
    IF h>PI2 THEN h:=PI2-h END;
    h:=sin(dist.lat)*sin(home.lat) + cos(dist.lat)*cos(home.lat)*cos(h);
    IF ABS(h)>=1.0 THEN RETURN 0.0 END;
    RETURN 6370.0*arccos(h)
  END;
(*
EXCEPT                  (* EXCEPT + procinline compiles to junk *)

  IO.WrLn; IO.WrStrLn(" rechenfehler ");
  RETURN 0.5;
*)
END distance;


PROCEDURE azimuth(home,dist:POSITION):CARDINAL;
VAR h:INTEGER;
    ldiff:REAL;
BEGIN
  ldiff:=dist.long-home.long;
  IF (ldiff=0.0) OR (cos(home.lat)=0.0) OR (cos(dist.lat)=0.0) THEN
    IF home.lat<=dist.lat THEN RETURN 0 ELSE RETURN 180 END;
  ELSE
    h:=round(360.0/PI2*arctan(cos(home.lat)*((tan(home.lat)*cos(ldiff)-tan(dist.lat))/sin(ldiff))));
    IF ldiff<0.0 THEN RETURN h+270 ELSE RETURN h+90 END;
  END;
END azimuth;



PROCEDURE GetPos(VAR pos:POSITION; buf-:ARRAY OF CHAR; micedest, payload:CARDINAL);

  PROCEDURE dig(VAR s:REAL; c:CHAR; mul:REAL):BOOLEAN;
  BEGIN
    IF c=" " THEN RETURN TRUE END;                     (* ambiguity *)
    IF (c<"0") OR (c>"9") THEN RETURN FALSE END;
    s:=s + FLOAT(ORD(c)-ORD("0"))*mul;
    RETURN TRUE
  END dig;

  PROCEDURE r91(VAR s:REAL; c:CHAR; mul:REAL):BOOLEAN;
  BEGIN
    IF (c<CHR(33)) OR (c>CHR(33+91)) THEN RETURN FALSE END;
    s:=s + FLOAT(ORD(c)-33)*mul;
    RETURN TRUE
  END r91;

  PROCEDURE mic(VAR s:REAL; c:CHAR; mul:REAL):BOOLEAN;
  VAR n:CARDINAL;
  BEGIN
    IF  (c>="0") & (c<="9") THEN n:=ORD(c)-ORD("0")
    ELSIF (c>="A") & (c<="J") THEN n:=ORD(c)-ORD("A")
    ELSIF (c="K") OR (c="L") OR (c="Z") THEN n:=0
    ELSIF (c>="P") & (c<="Y") THEN n:=ORD(c)-ORD("P")
    ELSE RETURN FALSE END;
    s:=s + FLOAT(n)*mul;
    RETURN TRUE
  END mic;

  PROCEDURE bit5(c:CHAR):BOOLEAN;
  BEGIN RETURN ODD(ORD(c) DIV 32) OR (c="L") END bit5;       (* L is wildcard *)

  PROCEDURE komma(VAR p:CARDINAL);
  BEGIN WHILE (p<HIGH(buf)) & (buf[p]<>0C) & (buf[p]<>",") DO INC(p) END; INC(p) END komma;

  PROCEDURE ns(c:CHAR):BOOLEAN;
  BEGIN c:=CAP(c); RETURN (c="N") OR (c="S") END ns;

  PROCEDURE ew(c:CHAR):BOOLEAN;
  BEGIN c:=CAP(c); RETURN (c="E") OR (c="W") END ew;



VAR i,len,n:CARDINAL;
    c:CHAR;
    ok:BOOLEAN;

BEGIN
  len:=payload;
(*
IO.WrStr(" index="); IO.WrCard(len, 1); IO.WrLn;
*)
  WHILE (len<HIGH(buf)) & (buf[len]<>0C) DO INC(len) END;

  c:=buf[payload];
  IF (payload+3<len) & (micedest>0) 
  & ((c=CHR(01CH)) OR (c=CHR(01DH)) OR (c=CHR(027H)) OR (c=CHR(060H))) THEN (* mic-e *)
    pos.lat:=0.0;
    i:=micedest;
    ok:=TRUE;
            IF NOT mic(pos.lat, buf[i], 10.0*RAD) THEN ok:=FALSE END;
    INC(i); IF NOT mic(pos.lat, buf[i], 1.0*RAD) THEN ok:=FALSE END;
    INC(i); IF NOT mic(pos.lat, buf[i], 10.0/60.0*RAD) THEN ok:=FALSE END;
    INC(i); IF NOT mic(pos.lat, buf[i], 1.0/60.0*RAD) THEN ok:=FALSE END;
    INC(i); IF NOT mic(pos.lat, buf[i], 0.1/60.0*RAD) THEN ok:=FALSE END;
    INC(i); IF NOT mic(pos.lat, buf[i], 0.01/60.0*RAD) THEN ok:=FALSE END;
    IF bit5(buf[micedest+3]) THEN pos.lat:=-pos.lat END;   (* south *)

    n:=ORD(buf[payload+1]);                                    (* long degrees *)
    IF n>=28 THEN
      DEC(n, 28);
      IF NOT bit5(buf[micedest+4]) THEN INC(n, 100) END; 
      IF (n>=180) & (n<=189) THEN DEC(n, 80)
      ELSIF (n>=190) & (n<=199) THEN DEC(n, 190) END;
    ELSE ok:=FALSE END;
    pos.long:=FLOAT(n)*RAD;

    n:=ORD(buf[payload+2]);                                    (* long min *)
    IF n>=28 THEN
      DEC(n, 28);
      IF n>=60 THEN DEC(n, 60) END;
    ELSE ok:=FALSE END;
    pos.long:=pos.long+FLOAT(n)*(RAD/60.0);


    n:=ORD(buf[payload+3]);                                    (* long min/100 *)
    IF n>=28 THEN pos.long:=pos.long+FLOAT(n-28)*(RAD/6000.0);
    ELSE ok:=FALSE END;

    IF bit5(buf[micedest+5]) THEN pos.long:=-pos.long END;   (* east *)

  ELSIF c="$" THEN                       (* gps 4806.9409,N,01134.6219,E *)
    ok:=FALSE;
    IF (buf[payload+1]="G") & (buf[payload+2]="P") THEN
      i:=payload+7;
      IF (buf[payload+3]="G") & (buf[payload+4]="G") & (buf[payload+5]="A") THEN 
        komma(i);
        ok:=TRUE;
      ELSIF (buf[payload+3]="R") & (buf[payload+4]="M") & (buf[payload+5]="C") THEN 
        komma(i);
        komma(i);
        ok:=TRUE;
      ELSIF (buf[payload+3]="G") & (buf[payload+4]="L") & (buf[payload+5]="L") THEN 
        ok:=TRUE;
      END;

      pos.lat:=0.0;
               IF NOT dig(pos.lat, buf[i], RAD*10.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.lat, buf[i], RAD) THEN ok:=FALSE END;    
      INC(i);  IF NOT dig(pos.lat, buf[i], RAD/6.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.lat, buf[i], RAD/60.0) THEN ok:=FALSE END;
      INC(i,2);IF NOT dig(pos.lat, buf[i], RAD/600.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.lat, buf[i], RAD/6000.0) THEN ok:=FALSE END;
      komma(i);
      IF buf[i]="S" THEN pos.lat:=-pos.lat END;
      komma(i);

      pos.long:=0.0;
               IF NOT dig(pos.long, buf[i], RAD*100.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.long, buf[i], RAD*10.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.long, buf[i], RAD) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.long, buf[i], RAD/6.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.long, buf[i], RAD/60.0) THEN ok:=FALSE END;
      INC(i,2);IF NOT dig(pos.long, buf[i], RAD/600.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.long, buf[i], RAD/6000.0) THEN ok:=FALSE END;
      komma(i);
      IF buf[i]="E" THEN pos.long:=-pos.long END;
    END;

  ELSE
(* !4915.10N/01402.20E& *)
(* xnnnn.nnNxnnnnn.nnEx *)
    ok:=FALSE;
    pos.lat:=0.0;
    pos.long:=0.0;
    i:=0; 
    IF (buf[payload]="!") OR (buf[payload]="=") THEN i:=payload+1
    ELSIF (buf[payload]="/") OR (buf[payload]="@") THEN i:=payload+8    (* skip time *)
    ELSIF buf[payload]=";" THEN i:=payload+18                           (* skip object *)
    ELSIF buf[payload]=")" THEN                                         (* skip item *)
      i:=payload+4; 
      WHILE (i<len) & (buf[i]<>"|") & (buf[i]<>"_") DO INC(i) END;
    END;

    IF i>0 THEN
      IF (buf[i]>="0") & (buf[i]<="9") THEN
        IF (i+17<=len)  & (buf[i+4]=".") & (buf[i+14]=".") 
        & ns(buf[i+7]) & ew(buf[i+17]) THEN                            (* not compressed *)
          ok:=TRUE;
                    IF NOT dig(pos.lat, buf[i], 10.0*RAD) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.lat, buf[i], 1.0*RAD) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.lat, buf[i], 10.0*RAD/60.0) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.lat, buf[i], 1.0*RAD/60.0) THEN ok:=FALSE END;
          INC(i,2); IF NOT dig(pos.lat, buf[i], 0.1*RAD/60.0) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.lat, buf[i], 0.01*RAD/60.0) THEN ok:=FALSE END;
          INC(i);   IF CAP(buf[i])="S" THEN pos.lat:=-pos.lat
                    ELSIF CAP(buf[i])<>"N" THEN ok:=FALSE END;

          INC(i,2); IF NOT dig(pos.long, buf[i], 100.0*RAD) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.long, buf[i], 10.0*RAD) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.long, buf[i], 1.0*RAD) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.long, buf[i], 10.0*RAD/60.0) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.long, buf[i], 1.0*RAD/60.0) THEN ok:=FALSE END;
          INC(i,2); IF NOT dig(pos.long, buf[i], 0.1*RAD/60.0) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.long, buf[i], 0.01*RAD/60.0) THEN ok:=FALSE END;
          INC(i);   IF CAP(buf[i])="E" THEN pos.long:=-pos.long
          ELSIF CAP(buf[i])<>"W" THEN ok:=FALSE END;
        END;

      ELSE  
        IF i+13<=len THEN                                                  (* compressed pos*)
          ok:=TRUE;
          INC(i); IF NOT r91(pos.lat, buf[i], 91.0*91.0*91.0) THEN ok:=FALSE END;      
          INC(i); IF NOT r91(pos.lat, buf[i], 91.0*91.0) THEN ok:=FALSE END;
          INC(i); IF NOT r91(pos.lat, buf[i], 91.0) THEN ok:=FALSE END;
          INC(i); IF NOT r91(pos.lat, buf[i], 1.0) THEN ok:=FALSE END;
          pos.lat:=90.0*RAD - pos.lat*(RAD/380926.0);
          INC(i); IF NOT r91(pos.long, buf[i], 91.0*91.0*91.0) THEN ok:=FALSE END;
          INC(i); IF NOT r91(pos.long, buf[i], 91.0*91.0) THEN ok:=FALSE END;
          INC(i); IF NOT r91(pos.long, buf[i], 91.0) THEN ok:=FALSE END;
          INC(i); IF NOT r91(pos.long, buf[i], 1.0) THEN ok:=FALSE END;
          pos.long:=180.0*RAD - pos.long*(RAD/190463.0);
        END;
      END;  
    END;
    
  
  END;
  ok:=ok & (pos.long<>0.0) & (pos.lat<>0.0) 
         & (ABS(pos.long)<180.0*RAD) & (ABS(pos.lat)<90.0*RAD);
  IF NOT ok THEN pos.long:=0.0; pos.lat:=0.0 END;

END GetPos;



END aprspos.
