<*+M2EXTENSIONS *>
<*-CHECKDIV *>
<*-CHECKRANGE *>
<*-COVERFLOW *>
<*-IOVERFLOW*>
<*+PROCINLINE*>
<*+NOPTRALIAS*>
<*-GENHISTORY*>
<*-CHECKNIL *>
<*-GENDEBUG*>
<*-LINENO*>
<*-CHECKINDEX*>
<*-CHECKSET*>
<*CPU="PENTIUM"*>


IMPLEMENTATION MODULE aprsstr (* string lib by oe5dxl *);


PROCEDURE Assign(VAR a:ARRAY OF CHAR; b-:ARRAY OF CHAR);
VAR i:CARDINAL;
BEGIN
  i:=0;
  LOOP
    a[i]:=b[i];
    IF (a[i]=0C) OR (i>=HIGH(a)) THEN RETURN END;
    INC(i);
    IF i>HIGH(b) THEN
      IF i<=HIGH(a) THEN a[i]:=0C END;
    RETURN END;
  END
END Assign;

PROCEDURE Append(VAR a:ARRAY OF CHAR; b-:ARRAY OF CHAR);
VAR i,j:CARDINAL;
BEGIN
  j:=Length(a);
  i:=0;
  LOOP
    IF j>HIGH(a) THEN RETURN END;
    a[j]:=b[i];
    IF a[j]=0C THEN RETURN END;
    INC(i);
    INC(j);
    IF i>HIGH(b) THEN
      IF j<=HIGH(a) THEN a[j]:=0C END;
    RETURN END;
  END
END Append;


PROCEDURE Length(a-:ARRAY OF CHAR):CARDINAL;
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE (i<=HIGH(a)) & (a[i]<>0C) DO INC(i) END;
  RETURN i
END Length;

PROCEDURE IntToStr(x:INTEGER; f:CARDINAL; VAR s:ARRAY OF CHAR);
VAR i,j:CARDINAL;
    neg:BOOLEAN;
BEGIN
  s[HIGH(s)]:=0C;
  i:=HIGH(s);
  IF x<0 THEN x:=-x; neg:=TRUE ELSE neg:=FALSE END;
  REPEAT
    DEC(i);
    s[i]:=CHR(x MOD 10+ORD("0"));
    x:=VAL(CARDINAL, x) DIV 10;
  UNTIL (x=0) OR (i=0);
  IF neg & (i>0) THEN DEC(i); s[i]:="-" END;
  IF f<HIGH(s) THEN f:=HIGH(s)-f ELSE f:=1 END;
  WHILE i>f DO
    DEC(i);
    s[i]:=" ";
  END;
  IF i>0 THEN
    j:=0;
    WHILE i<=HIGH(s) DO
      s[j]:=s[i];
      INC(j);
      INC(i);
    END;
  END;
END IntToStr;

PROCEDURE FixToStr(x:REAL; f:CARDINAL; VAR s:ARRAY OF CHAR);
VAR i  :CARDINAL;
    n  :INTEGER;
    neg:BOOLEAN;
BEGIN
  neg:=x<0.0;
  IF neg THEN x:=-x END;
  n:=TRUNC(x);
  x:=x-FLOAT(n);
  IF neg THEN n:=-n END;
  IntToStr(n,1,s);
  i:=Length(s);

  IF f>0 THEN
    s[i]:=".";
    INC(i);
    WHILE (f>1) & (x>0.0) DO
      x:=x*10.0;
      n:=TRUNC(x);
      x:=x-FLOAT(n);
      s[i]:=CHR(n+ORD("0"));
      INC(i);
      DEC(f);
    END;
    s[i]:=0C;
  END;
END FixToStr;

PROCEDURE StrToCard(VAR s: ARRAY OF CHAR; VAR x:CARDINAL): BOOLEAN;
VAR i:CARDINAL;
    ok:BOOLEAN;
BEGIN
  x:=0;
  ok:=FALSE;
  FOR i:=0 TO HIGH(s) DO
    IF (s[i]>="0") & (s[i]<="9") THEN x:=x*10+(ORD(s[i])-ORD("0")); ok:=TRUE
    ELSE RETURN ok & (s[i]=0C) END;
  END;
  RETURN ok;
END StrToCard;

PROCEDURE StrToInt(VAR s: ARRAY OF CHAR; VAR x:INTEGER): BOOLEAN;
VAR i:CARDINAL;
    ok:BOOLEAN;
BEGIN
  x:=0;
  ok:=FALSE;
  i:=0;
  IF s[0]="-" THEN INC(i) END;
  WHILE (i<=HIGH(s)) & (s[i]>="0") & (s[i]<="9") DO
    x:=x*10+VAL(INTEGER, ORD(s[i])-ORD("0"));
    ok:=TRUE;
    INC(i);
  END;
  IF (i>HIGH(s)) OR (s[i]<>0C) THEN ok:=FALSE END;
  IF s[0]="-" THEN x:=-x END;
  RETURN ok
END StrToInt;


PROCEDURE StrToFix(VAR x:REAL; VAR s:ARRAY OF CHAR):BOOLEAN;
CONST M=MAX(REAL)/100.0;
VAR i:CARDINAL;
    p:REAL;
    neg, ok:BOOLEAN;
BEGIN
  i:=0;
  neg:=FALSE;
  ok:=FALSE;
  WHILE (i<=HIGH(s)) & (s[i]=" ") DO INC(i) END;
  IF s[i]="-" THEN neg:=TRUE; INC(i) END;
  x:=0.0;
  WHILE (i<=HIGH(s)) & (s[i]>="0") & (s[i]<="9") DO
    IF x<M THEN x:=x*10.0 + FLOAT(ORD(s[i])-ORD("0")) END;
    INC(i);
    ok:=TRUE;
  END;
  IF (i<=HIGH(s)) & (s[i]=".") THEN
    INC(i);
    p:=0.1;
    WHILE (i<=HIGH(s)) & (s[i]>="0") & (s[i]<="9") DO
      x:=x + p*FLOAT(ORD(s[i])-ORD("0"));
      p:=p*0.1;
      INC(i);
      ok:=TRUE;
    END;
  END;
  IF neg THEN x:=-x END;
  RETURN ok & ((i>HIGH(s)) OR (s[i]=0C))
END StrToFix;


PROCEDURE StrCmp(a-,b-:ARRAY OF CHAR):BOOLEAN;
VAR i:CARDINAL;
BEGIN
  i:=0;
  LOOP
    IF a[i]<>b[i] THEN RETURN FALSE
    ELSIF (a[i]=0C) OR (i>=HIGH(a)) OR (i>=HIGH(b)) THEN RETURN TRUE END;
    INC(i);
  END
END StrCmp;


PROCEDURE TimeToStr(t:TIME; VAR s:ARRAY OF CHAR);
VAR h:ARRAY[0..20] OF CHAR;
BEGIN
  IntToStr(t DIV (60*60), 1 , s); Append(s,":");
  IntToStr(t DIV 60 MOD 60, 2, h); IF h[0]=" " THEN h[0]:="0" END;
  Append(s, h); Append(s,":");
  IntToStr(t MOD 60, 2, h); IF h[0]=" " THEN h[0]:="0" END; Append(s, h);
END TimeToStr;

PROCEDURE DateToStr(time:CARDINAL; VAR tstr:ARRAY OF CHAR);
VAR mon, year, day, monthlen:CARDINAL;
    k:ARRAY[0..12] OF CHAR;

PROCEDURE tostr(n:CARDINAL; s-:ARRAY OF CHAR);
VAR h:ARRAY[0..1] OF CHAR;
BEGIN
  h[1]:=0C;
  h[0]:=CHR(ORD('0')+n DIV 10);
  Append(tstr,h);
  h[0]:=CHR(ORD('0')+n MOD 10);
  Append(tstr,h);
  Append(tstr,s);
END tostr;

BEGIN
  tstr[0]:=0C;
  day:=25567+time DIV (60*60*24);
  IF day>=36584 THEN INC(day) END;
  year:=day*4 DIV 1461;
  day:=1 + day*4 MOD 1461 DIV 4;
  mon:=0;
  k[0]:=0C;
  Append(k,'3303232332323');
  IF year MOD 4 = 0 THEN k[2]:='1' END;
  LOOP
    INC(mon);
    monthlen:=ORD(k[mon])-20;
    IF day<=monthlen THEN EXIT END;
    DEC(day, monthlen);
  END;
  tostr(19+year DIV 100,'');
  tostr(year MOD 100,'.');
  tostr(mon,'.');
  tostr(day,' ');
  tostr(time DIV (60*60) MOD 24,':');
  tostr(time DIV 60 MOD 60,':');
  tostr(time MOD 60,'');
END DateToStr;

PROCEDURE CtrlHex(VAR s:ARRAY OF CHAR);              (* replace ctrl char by <hex> *)

  PROCEDURE Hex(d:CARDINAL):CHAR;
  BEGIN
    d:=d MOD 16;
    IF d>9 THEN INC(d, ORD("A")-10-ORD("0")) END;
    RETURN CHR(d+ORD("0"))
  END Hex;

VAR i,j,len:CARDINAL;
BEGIN
  len:=Length(s);
  i:=0;
  WHILE (i<len) & (len<HIGH(s)-4) DO
    IF s[i]<" " THEN
      INC(len, 3);
      FOR j:=len TO i+4 BY -1 DO s[j]:=s[j-3] END;
      j:=ORD(s[i]);
      s[i]:="<"; INC(i);
      s[i]:=Hex(j DIV 16); INC(i);
      s[i]:=Hex(j); INC(i);
      s[i]:=">";
    END;
    INC(i);
  END;
  s[i]:=0C;
END CtrlHex;



END aprsstr.
