<*+M2EXTENSIONS *>
<*-CHECKDIV *>
<*-CHECKRANGE *>
<*-COVERFLOW *>
<*-IOVERFLOW*>
<*+PROCINLINE*>
<*+NOPTRALIAS*>
<*-GENHISTORY*>
<*-CHECKNIL *>
<*-GENDEBUG*>
<*-LINENO*>
<*-CHECKINDEX*>
<*-CHECKSET*>
<*CPU="PENTIUM"*>

MODULE udpbox; (* axudp in/out ui/aprs stream splitter, filter, digipeater by OE5DXL *)

IMPORT IO, udp;
FROM FdSet IMPORT FdSet, FD_ZERO, FD_SET, FD_ISSET, TimeVal;
FROM mlib IMPORT select;
FROM SYSTEM IMPORT CAST, SHIFT, ADR, CARD8;
FROM Storage IMPORT ALLOCATE;
FROM Lib IMPORT NextArg;
FROM TimeConv IMPORT time; 
FROM FIO IMPORT OpenMode, Close, oRDONLY, oAPPEND, oWRONLY, oNONBLOCK, Create, WrBin, RdBin, File;
FROM aprspos IMPORT GetPos, distance, POSITION, RAD, posvalid;
FROM aprsstr IMPORT TIME ,Assign, Append, Length, StrToFix,
     StrCmp, TimeToStr, CtrlHex;

CONST CALLLEN=7;
      HASHSIZE=16384;

      NOTFIRSTDIGI=3;
      NOUPLINKCHECK=4;
      SENDTRACE=5;
      SENDWIDE=6;
      DOWNPATHDIGICALL=7;
      DOWNPATHRELAY=8;
      DOWNPATHALL=9;
      NOVIADIGICALL=10;
      NOVIARELAY=11;
      NOVIATRACE=12;
      NOVIAWIDEN=13;
      NOCALLBEFOREWIDE=14;
      NOSSIDROUTE=15;
      NULLSSID=16;
      KILLWIDE=17;

TYPE  UDPPORT=CARDINAL;
      IPNUM=CARDINAL;
      SET8=SET OF [0..7];
      PATHSET=SET OF [0..31];
      SET256=SET OF [0..255];
      RAWCALL=ARRAY[0..CALLLEN-1] OF CHAR; 
      MONCALL=ARRAY[0..8] OF CHAR;
      FILENAME=ARRAY[0..1023] OF CHAR;

      pDIGIPARMS=POINTER TO DIGIPARMS;
      DIGIPARMS=RECORD
                  digicall              : RAWCALL;
                  pathcheck             : PATHSET;
                  duptime, messagetime  : TIME;
                  timehash              : ARRAY[0..HASHSIZE-1] OF TIME;
                END;

      BEACON=RECORD
               bintervall: TIME;
               bfile     : FILENAME;
               btime     : TIME;
             END;


      pCALLS=POINTER TO CALLS;
      CALLS=RECORD
              next      : pCALLS;
              call      : RAWCALL;
            END;

      pOUTPORT=POINTER TO OUTPORT;
      OUTPORT=RECORD
                next       : pOUTPORT;
                toip       : IPNUM;   
                toport     : UDPPORT;
                filtercalls: pCALLS;
                echo, rawwrite, crlfwrite, passnoUI: BOOLEAN;
                aprspass   : SET256;
                digiparm   : pDIGIPARMS;
                beacon     : BEACON;
                mypos      : POSITION;
                maxkm      : INTEGER;
              END;
      
      pINSOCK=POINTER TO INSOCK;
      INSOCK=RECORD
               next    : pINSOCK;
               fd      : INTEGER;
               rawread : BOOLEAN;
               fromip  : IPNUM;
               bindport: UDPPORT;
               outchain: pOUTPORT;
             END; 

      pMSGHASH=POINTER TO MSGHASH; 
      MSGHASH=RECORD
                next    : pMSGHASH;
                usercall: MONCALL;
                msgfile : FILENAME;
                wpos    : CARDINAL;
                hash:ARRAY[0..15] OF RECORD
                  sums, ackcnt:CARDINAL;
                  acktime: TIME;
                  source : pINSOCK;
                  froms  : MONCALL;
                  acks   : ARRAY[0..5] OF CHAR;
                END;
              END;  


CONST MAXLEN=256+7*10+10+2;
      MINLEN=7*2+1+2;
      BLANKH=CHR(ORD(" ")*2);
      HBIT=128;
      ACKMSG="ack";
      POLYNOM=BITSET{3,10,15};
      CRCINIT=BITSET{0..15};
      CRCRESULT=BITSET(40715);
      cFILTPASS="p";
      cFILTDEL="d";
      DEFAULTMESSAGETIME=28;                      (* block seconds user message frames *)
      DEFAULTDUPTIME=29*60;                       (* block seconds invariant payload frames *)
      CR=015C;
      LF=012C;
      SENDACKS=4;
      OLDMSG=600;                                 (* s long kill dupe user message *)
      TOCALL="APNL01";
      DEFAULTACK="WIDE2-2";
      cUSERMSG=":";

VAR CRCL, CRCH            : ARRAY[0..255] OF SET8;
    show                  : BOOLEAN;
    insocks               : pINSOCK;
    showip                : IPNUM;
    showport              : UDPPORT;
    msgusers              : pMSGHASH; 
    ackpath               : ARRAY[0..63] OF CHAR;
    mypos                 : POSITION;

PROCEDURE Err(text-:ARRAY OF CHAR);
BEGIN
  IO.WrStr(text); IO.WrStrLn(" error abort");
  HALT
END Err;


PROCEDURE Gencrctab;
CONST POLINOM=08408H;
VAR i,crc,c:CARDINAL;
BEGIN
  FOR c:=0 TO 255 DO
    crc:=255-c;
    FOR i:=0 TO 7 DO
      IF ODD(crc) THEN crc:=CAST(CARDINAL, CAST(BITSET, ASH(crc, -1))/CAST(BITSET,POLINOM))
      ELSE crc:=ASH(crc, -1) END;
    END;
    CRCL[c]:=CAST(SET8, crc);
    CRCH[c]:=CAST(SET8, 255 - ASH(crc, -8));
  END;
END Gencrctab;




PROCEDURE AppCRC(VAR frame:ARRAY OF CHAR; size:INTEGER);
VAR l,h:SET8;
    b:CARD8;
    i:INTEGER;
BEGIN
  l:=SET8{};
  h:=SET8{};
  FOR i:=0 TO size-1 DO
    b:=CAST(CARD8, CAST(SET8, frame[i]) / l);
    l:=CRCL[b] / h;
    h:=CRCH[b];
  END;
  frame[size  ]:=CAST(CHAR, l);
  frame[size+1]:=CAST(CHAR, h);
END AppCRC;

PROCEDURE Hash(frame-:ARRAY OF CHAR; start, end:INTEGER):CARDINAL;
VAR l,h:SET8;
    b:CARD8;
    i:INTEGER;
    c:CHAR;
BEGIN
  l:=SET8{};
  h:=SET8{};
  FOR i:=start TO end-1 DO
    c:=frame[i];
    IF c<>" " THEN
      b:=CAST(CARD8, CAST(SET8, c) / l);
      l:=CRCL[b] / h;
      h:=CRCH[b];
    END;
  END;
  RETURN (ORD(CAST(CHAR, l)) + ORD(CAST(CHAR, h))*256) MOD HASHSIZE;
END Hash;


PROCEDURE Call2Str(r-:ARRAY OF CHAR; VAR t:ARRAY OF CHAR; pos:CARDINAL; VAR len:CARDINAL):BOOLEAN;
VAR i,e,ssid:CARDINAL;
    c:CHAR;
BEGIN
  e:=pos;
  FOR i:=pos TO pos+5 DO 
    IF r[i]<>100C THEN e:=i END;
  END; 
  FOR i:=pos TO e DO 
    c:=CHR(ASH(ORD(r[i]), -1));
    IF c<=" " THEN len:=0; RETURN FALSE END;
    t[len]:=c;
    INC(len);
  END;
  ssid:=ASH(ORD(r[pos+6]), -1) MOD 16;
  IF ssid>0 THEN 
    t[len]:="-"; INC(len); 
    IF ssid>9 THEN t[len]:="1"; INC(len); END;
    t[len]:=CHR(ssid MOD 10 + ORD("0")); INC(len);
  END;
  RETURN TRUE
END Call2Str;

PROCEDURE Stomsg(user:pMSGHASH; from-, to-, msg-, ack-:ARRAY OF CHAR; fromsock:pINSOCK);
VAR i,j,h:CARDINAL;
    t:TIME;
    f:File;
    mb:ARRAY[0..255] OF CHAR;
BEGIN
  WITH user^ DO
    i:=0;
    WHILE (i<=HIGH(msg)) & (msg[i]<>0C) DO INC(i) END;
    t:=time();
    h:=Hash(msg, 0, i);
    i:=0;
    WHILE (i<=HIGH(hash)) & NOT ((h=hash[i].sums) & (hash[i].acktime+OLDMSG>=t) 
    & StrCmp(ack, hash[i].acks) & StrCmp(from, hash[i].froms)) DO INC(i) END;
    IF i>HIGH(hash) THEN                                                        (* new msg*)

      TimeToStr(t,mb);
      Append(mb, " from ");
      Append(mb, from);
      Append(mb, " to ");
      Append(mb, to);
      Append(mb, " <");
      Append(mb, msg);
      Append(mb, "> (");
      Append(mb, ack);
      Append(mb, ")");

IF show THEN  IO.WrStr(" <"); IO.WrStr(mb); IO.WrStr("> "); END;

      Append(mb, 12C);

      IF msgfile[0]<>0C THEN
        f:=OpenMode(msgfile, oWRONLY+oAPPEND+oNONBLOCK);
        IF f<0 THEN f:=Create(msgfile) END;
        IF f>=0 THEN
          WrBin(f, mb, Length(mb));
          Close(f);
        END; 
      END;

      WITH hash[wpos] DO
        sums:=h;
        Assign(acks, ack);
        Assign(froms, from);
        IF ack[0]>" " THEN 
          ackcnt:=SENDACKS;
          acktime:=0;
        END;
        source:=fromsock;
      END;
      INC(wpos);
      IF wpos>HIGH(hash) THEN wpos:=0 END;    
    ELSE                                                                              (* old msg *)
      hash[i].ackcnt:=SENDACKS;
    END;
  END;
END Stomsg;

PROCEDURE Usermsg(b-:ARRAY OF CHAR; len,p:INTEGER; parm:pOUTPORT; fromsock:pINSOCK):BOOLEAN;
CONST THIRDPARTY="}";
      HEADEREND=":";
      FROMEND=">";
      USERACK="{";

VAR pf:INTEGER;
    j:CARDINAL; 
    user:pMSGHASH;
    from, to:ARRAY[0..8] OF CHAR;
    ack:ARRAY[0..5] OF CHAR;
    msg:ARRAY[0..68] OF CHAR;
BEGIN
  pf:=0;                                                              (* from whom *)
  WHILE b[p]=THIRDPARTY DO                                            (* remove third party header *)
    pf:=p+1;
    WHILE (p<len) & (b[p]<>HEADEREND) DO INC(p) END;
    INC(p);
  END;

  IF (p+10<len) & (b[p]=cUSERMSG) & (b[p+10]=cUSERMSG) THEN           (* user message *)
    INC(p); 

    user:=msgusers;
    WHILE user<>NIL DO
      j:=0;
      WHILE (j<9) & (user^.usercall[j]=b[p+VAL(INTEGER,j)]) DO INC(j) END; 

      IF j=9 THEN 
        j:=0;
        IF pf=0 THEN
          IF Call2Str(b, from, 7, j) THEN END;
        ELSE 
          WHILE (pf<len) & (j<=HIGH(from)) & (b[pf]<>FROMEND) DO from[j]:=b[pf]; INC(pf); INC(j); END;
        END;
        WHILE j<=HIGH(from) DO from[j]:=" "; INC(j) END; 

        FOR j:=0 TO 8 DO to[j]:=b[p]; INC(p) END;
        INC(p); 

        j:=0;
        WHILE (p<len) & (j<HIGH(msg)) & (b[p]<>USERACK) DO msg[j]:=b[p]; INC(j); INC(p) END;
        msg[j]:=0C;
        
        j:=0;
        LOOP
          IF ACKMSG[j]<=" " THEN RETURN FALSE END;   (* "ack" in text field is not for delete *)
          IF ACKMSG[j]<>msg[j] THEN EXIT END;
          INC(j);
        END;

        INC(p);

        j:=0;
        WHILE (p<len) & (j<HIGH(ack)) DO ack[j]:=b[p]; INC(j); INC(p) END;
        ack[j]:=0C;

        Stomsg(user, from, to, msg, ack, fromsock);
        RETURN TRUE
      END;
      user:=user^.next;
    END; 
  END;
  RETURN FALSE
END Usermsg;


PROCEDURE CallFilt(calls:pCALLS; s-:ARRAY OF CHAR; len:INTEGER):BOOLEAN;
VAR i, j:INTEGER;
    c:pCALLS;
CONST  WILDH=CHR(ORD("*")*2);
BEGIN
  i:=0;
  REPEAT
    c:=calls;
    WHILE c<>NIL DO  
      j:=0;
      LOOP
        IF (c^.call[j]<>WILDH) & (c^.call[j]<>s[i+j]) THEN EXIT END;
        INC(j);
        IF j>=CALLLEN-1 THEN 
          IF (c^.call[j]<>0C) 
          & (CAST(SET8, c^.call[j])*SET8{1..4}<>CAST(SET8, s[i+j])*SET8{1..4}) THEN EXIT END;
          RETURN TRUE
        END;
      END; 
      c:=c^.next;
    END;
    INC(i, CALLLEN);
  UNTIL (i>=len) OR ODD(ORD(s[i-1]));
  RETURN FALSE;
END CallFilt;


PROCEDURE DistFilt(mypos:POSITION; b:ARRAY OF CHAR; payload, len:CARDINAL):INTEGER;
VAR i:CARDINAL;
    pos:POSITION;
BEGIN
  FOR i:=CALLLEN-1 TO 0 BY -1 DO b[i+1]:=CAST(CHAR, SHIFT(CAST(SET8,b[i]), -1)) END;
  b[len]:=0C;
  GetPos(pos, b, 1, payload);
  IF posvalid(pos) THEN
    RETURN TRUNC(distance(mypos,pos))
  ELSE RETURN -1 END;
END DistFilt;  


PROCEDURE Filter(b-:ARRAY OF CHAR; len:INTEGER; parm:pOUTPORT; fromsock:pINSOCK):BOOLEAN;
VAR i:INTEGER;
    km:INTEGER;
BEGIN
  DEC(len,2);                                                      (* crc *)  
  i:=13;
  WHILE (i<len) & NOT ODD(ORD(b[i])) DO INC(i, 7) END;
  INC(i,3); 
  IF (i>len) OR (CAST(SET8, b[i-2])-SET8{4}<>SET8{0,1}) THEN 

IF show THEN IO.WrStr(" not UI ") END;

  RETURN parm^.passnoUI END; (* not UI frame *)                                                               (* first payload byte *)
(* is UI frame *)
  IF Usermsg(b, len, i, parm, fromsock) THEN RETURN FALSE END;  
  IF (parm^.filtercalls<>NIL) & CallFilt(parm^.filtercalls, b, len) THEN 
IF show THEN IO.WrStr(" callfilter match") END;
    RETURN FALSE
  END; 

  IF NOT (ORD(b[i]) IN parm^.aprspass) THEN 
IF show THEN IO.WrStr(" message type filter") END;
    RETURN FALSE
  END;

  IF (parm^.maxkm>0) & (b[i]<>cUSERMSG) THEN        (* dist filter on and no user message *) 
    km:=DistFilt(parm^.mypos, b, i, len);
    IF km<0 THEN
IF show THEN IO.WrStr(" no pos") END;
      RETURN FALSE
    END; 
IF show THEN IO.WrStr(" "); IO.WrCard(km,1);IO.WrStr("km"); END;
    IF km>=parm^.maxkm THEN
IF show THEN IO.WrStr(" too far") END;
      RETURN FALSE
    END;  
  END;

  RETURN TRUE;
END Filter;



PROCEDURE getudp(fd:INTEGER; VAR buf:ARRAY OF CHAR; fromip:IPNUM; addcrc:BOOLEAN):INTEGER;
VAR fromport:UDPPORT;
    ip:IPNUM;
    crc1, crc2:CHAR;
    len:INTEGER;
BEGIN
  len:=udp.udpreceive(fd, buf, SIZE(buf), fromport, ip);
  IF (len>2) & (len<CAST(INTEGER, SIZE(buf))) & ((fromip=0) OR (fromip=ip)) THEN
    showip:=ip;
    showport:=fromport;
    IF NOT addcrc THEN RETURN len END;

    crc1:=buf[len-2];
    crc2:=buf[len-1];
    AppCRC(buf, len-2);
    IF (crc1=buf[len-2]) & (crc2=buf[len-1]) THEN RETURN len 
    ELSIF show THEN 
      IO.WrStr(" raw crc error "); 
(*
      IO.WrHex(ORD(crc1)+ORD(crc2)*256, 1);
      IO.WrStr("<>");
      IO.WrHex(ORD(buf[len-2])+ORD(buf[len-1])*256, 1);
      IO.WrStr("  ");
*)
    END; 

  END;
  RETURN -1
END getudp; 


PROCEDURE mon2raw(VAR mon, raw:ARRAY OF CHAR; VAR p:INTEGER);
CONST CTRL=CHR(3);
      PID=CHR(0F0H);
      cTO=">"; 
      cVIA=",";
      cLASTCALL=":";
      cSSID="-";
      cREPEATED="*";
      MAXVIAS=8;
      MAXSSID=15;
      SSIDBASE=16*3;
      CALLFILL=" ";
      
VAR i,n,r:CARDINAL;
    

PROCEDURE call(sep1, sep2, sep3:CHAR; sbase:CARDINAL):BOOLEAN;
VAR l,s:CARDINAL; 
BEGIN
  l:=0;
  WHILE (mon[i]<>0C) & (mon[i]<>sep1) & (mon[i]<>sep2) & (mon[i]<>sep3) & (mon[i]<>cSSID) DO
    s:=ORD(mon[i])*2 MOD 256;
    IF s<=ORD(" ")*2 THEN RETURN FALSE END;
    raw[p]:=CHR(s);
    INC(p);
    INC(i);
    INC(l);
    IF l>=CALLLEN THEN RETURN FALSE END;
  END;
  WHILE l<CALLLEN-1 DO
    raw[p]:=CHR(ORD(CALLFILL)*2);
    INC(p);
    INC(l);
  END;
  s:=0;
  IF mon[i]=cSSID THEN
    INC(i);
    WHILE (mon[i]>="0") & (mon[i]<="9") DO s:=s*10 + ORD(mon[i])-ORD("0"); INC(i) END;
    IF s>MAXSSID THEN RETURN FALSE END;    
  END;
  raw[p]:=CHR((s+sbase)*2);
  INC(p);
  RETURN TRUE
END call;

BEGIN
  p:=CALLLEN;
  i:=0;
  IF NOT call(cTO, 0C, 0C, SSIDBASE) THEN p:=0; RETURN END;            (* from call *)

  p:=0;
  IF mon[i]<>cTO THEN RETURN END;                                      (* ">" *)

  INC(i);
  IF NOT call(cLASTCALL, cVIA, 0C, SSIDBASE+64) THEN p:=0; RETURN END; (* dest call bit 7 for UI v2 command *)

  p:=CALLLEN*2;
  n:=0;
  WHILE mon[i]=cVIA DO
    INC(i);
    IF NOT call(cLASTCALL, cVIA, cREPEATED, SSIDBASE) THEN p:=0; RETURN END; 

    INC(n);
    IF n>MAXVIAS THEN p:=0; RETURN END;

    IF mon[i]=cREPEATED THEN                                           (* "*" has repeatet sign *)
      INC(i);
      FOR r:=p TO CALLLEN*3 BY -CALLLEN DO raw[r-1]:=CHR(ORD(raw[r-1])+HBIT) END; (* set "has repeated" flags *)
    END;
  END;
  IF (p=0) OR (mon[i]<>cLASTCALL) THEN p:=0; RETURN END;               (* ":" start of info sign *)

  raw[p-1]:=CHR(ORD(raw[p-1]) + 1);                                    (* end address field mark *)
  raw[p]:=CTRL;
  INC(p);
  raw[p]:=PID;
  INC(p);
  INC(i);
  WHILE (mon[i]<>0C) & (i<=HIGH(mon)) DO                               (* copy info part *)
    IF p>=VAL(INTEGER, HIGH(raw))-2 THEN p:=0; RETURN END;             (* spare 2 bytes for crc *)

    raw[p]:=mon[i];
    INC(p);
    INC(i);
  END;
  AppCRC(raw,p); 
  INC(p, 2);
END mon2raw;



PROCEDURE raw2mon(VAR raw, mon:ARRAY OF CHAR; len:INTEGER; VAR p:CARDINAL);
VAR i:INTEGER;
BEGIN
  p:=0;
  mon[p]:=0C;
  i:=0;
  WHILE NOT ODD(ORD(raw[i])) DO 
    INC(i);
    IF i>len THEN RETURN END;                         (* no address end mark found *)
  END;
  IF i MOD 7 <> 6 THEN RETURN END;                    (* address end not modulo 7 error *)

  IF NOT Call2Str(raw,mon,7,p) THEN RETURN END; 
  mon[p]:=">"; INC(p);
  IF NOT Call2Str(raw,mon,0,p) THEN RETURN END;

  i:=14;
  WHILE (i+6<len) & NOT ODD(ORD(raw[i-1])) DO
    mon[p]:=","; INC(p);
    IF NOT Call2Str(raw,mon,i,p) THEN RETURN END;

    IF (ORD(raw[i+6])>=128) & (ODD(ORD(raw[i+6])) OR (ORD(raw[i+13])<128)) 
    THEN mon[p]:="*"; INC(p); END;
    INC(i,7);
  END;  
  INC(i,2);  (* ctrl, pid *)

  mon[p]:=":"; INC(p);

  WHILE (i<len) & (p<HIGH(mon)-1) DO 
    IF raw[i]<>0C THEN mon[p]:=raw[i]; INC(p); END; 
    INC(i);
  END;
(*
  mon[p]:=15C; INC(p);
  mon[p]:=12C; INC(p);
*)
  mon[p]:=0C; INC(p);

  mon[p]:=0C;

END raw2mon;


PROCEDURE MakeDupeTime(s-:ARRAY OF CHAR; p:INTEGER; parm:pDIGIPARMS):TIME;
VAR le,nu:CARDINAL;
    i:INTEGER; 
BEGIN
  le:=0;
  nu:=0;
  FOR i:=p+3 TO p+5 DO 
    IF (s[i]>="A") & (s[i]<="Z") THEN INC(le) END;
    IF (s[i]>="0") & (s[i]<="9") THEN INC(nu) END;
  END;
  IF (s[p+2]=cUSERMSG) & (le>0) & (nu>0) & (le+nu=3) THEN        (* looks like a user message *)
    RETURN parm^.messagetime
  END;
  RETURN parm^.duptime
END MakeDupeTime;

PROCEDURE Cmp(s-:ARRAY OF CHAR; start:CARDINAL; word-:ARRAY OF CHAR):BOOLEAN;
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE word[i]<>0C DO
    IF word[i]<>CHR(ORD(s[start]) DIV 2) THEN RETURN FALSE END;
    INC(i);
    INC(start);
  END;
  RETURN TRUE
END Cmp;


PROCEDURE ChkNN(ssid:CARDINAL; c:CHAR):BOOLEAN;
BEGIN 
  c:=CHR(ORD(c) DIV 2);
  RETURN (c=" ") & (ssid=0) OR (c>="1") & (c<="7") & (c>=CHR(ORD("0")+ssid))
END ChkNN;

PROCEDURE NeqN(ssid:CARDINAL; c:CHAR; pos:INTEGER):BOOLEAN;
BEGIN RETURN (pos<=CALLLEN*2) & ((ssid+ORD("0")=ORD(c) DIV 2) OR (ssid=0) & (c=BLANKH)) END NeqN;


PROCEDURE setSSID(VAR c:CHAR; ssid:CARDINAL);
BEGIN c:=CAST(CHAR, CAST(SET8,c)-SET8{1..4}+CAST(SET8,ssid*2)) END setSSID;

PROCEDURE getSSID(c:CHAR):CARDINAL;
BEGIN RETURN ORD(c) DIV 2 MOD 16 END getSSID;

PROCEDURE killwide(VAR startpath:INTEGER; downpath:INTEGER; VAR s:ARRAY OF CHAR);
VAR i,j:INTEGER;
BEGIN
  FOR i:=startpath TO downpath-1 BY CALLLEN DO
    IF (s[i]=CHR(ORD("W")*2)) & (s[i+1]=CHR(ORD("I")*2))  
    & (s[i+2]=CHR(ORD("D")*2)) & (s[i+3]=CHR(ORD("E")*2)) THEN
      FOR j:=i-1 TO startpath BY -1 DO s[j+CALLLEN]:=s[j] END;
      INC(startpath, CALLLEN);
    END;
  END;
END killwide;


PROCEDURE Digi(VAR raw, send:ARRAY OF CHAR; inlen:INTEGER; VAR outlen:INTEGER; parm:pDIGIPARMS; duponly:BOOLEAN);
VAR i, j, pathlen, startpath, actdigi, downpath:INTEGER;
    ssid, hash, ssidroute:CARDINAL;
    t:TIME;
    ok, nodigicall:BOOLEAN;
BEGIN
  IF parm^.digicall[0]<=BLANKH THEN duponly:=TRUE END;
  outlen:=0;
  DEC(inlen, 2);                                              (* crc bytes *)

  pathlen:=CALLLEN*2-1;
  WHILE (pathlen<inlen) & NOT ODD(ORD(raw[pathlen])) DO INC(pathlen,CALLLEN) END; (* find end of path *)
  INC(pathlen);

  ok:=FALSE;
  downpath:=0;
  IF NOT duponly THEN
    actdigi:=CALLLEN*2;
    IF NOTFIRSTDIGI IN parm^.pathcheck THEN                   (* need not be first repeater *)
      WHILE (actdigi<pathlen) & (raw[actdigi+(CALLLEN-1)]>=CHR(128)) DO INC(actdigi,CALLLEN) END;
    END;

    startpath:=actdigi+CALLLEN;
    nodigicall:=FALSE;
    IF DOWNPATHALL IN parm^.pathcheck THEN downpath:=pathlen END;
    ssidroute:=0;
    IF pathlen=CALLLEN*2 THEN                                 (* no via use destination ssid routing *)
      ssidroute:=getSSID(raw[CALLLEN-1]);                     (* destination ssid *)
      IF (ssidroute>0) & NOT (NOSSIDROUTE IN parm^.pathcheck) THEN   (* ssid=0 is not digipeatable *) 
        ok:=TRUE;
        IF ssidroute>7 THEN ssidroute:=1 END;                 (* we can no directional routing *)
        ssid:=CAST(INTEGER, parm^.pathcheck*PATHSET{0..2});
        IF ssid=7 THEN 
          setSSID(raw[CALLLEN-1], ssidroute-1);               (* chain by dec dest ssid *)
          IF ssidroute>1 THEN nodigicall:=TRUE END;           (* sorry no traceing possible *)
          ssidroute:=0;
        ELSE                                                  (* expand to digicall + wideN-N *)
          IF ssidroute>ssid THEN ssidroute:=ssid END;         (* limit dest ssid to WIDEn-n *) 
          setSSID(raw[CALLLEN-1], 0);                         (* switch to via routing *)
        END;          
      END;

IF show THEN 
  IF ok THEN IO.WrStr(" via ssid routing ") ELSE IO.WrStr(" no via, no ssid ") END;
END;

    ELSE
      ok:=(pathlen>actdigi) & (raw[actdigi+(CALLLEN-1)]<CHR(128));  (* there are via calls & is not digipeated *)
      IF ok THEN
        ssid:=getSSID(raw[actdigi+(CALLLEN-1)]);
        IF NOVIADIGICALL IN parm^.pathcheck THEN ok:=FALSE
        ELSE 
          FOR i:=0 TO CALLLEN-2 DO 
            IF raw[i+actdigi]<>parm^.digicall[i] THEN ok:=FALSE END;
          END;
          IF ssid<>getSSID(parm^.digicall[CALLLEN-1]) THEN ok:=FALSE END;
        END;
        IF ok THEN
          IF DOWNPATHDIGICALL IN parm^.pathcheck THEN downpath:=pathlen END;

IF show THEN IO.WrStr(" via digicall "); END;

        ELSE
          IF NOT (NOVIARELAY IN parm^.pathcheck) THEN
            ok:=Cmp(raw, actdigi, "RELAY ");
            IF ok THEN
            IF DOWNPATHRELAY IN parm^.pathcheck THEN downpath:=pathlen END;

IF show THEN IO.WrStr(" via RELAY "); END;

            END;
          END;  
        END;

        IF NOT ok THEN 
          IF NOT (NOVIATRACE IN parm^.pathcheck) 
          & Cmp(raw, actdigi, "TRACE")
          & ChkNN(ssid, raw[actdigi+(CALLLEN-2)])
          & ((NOUPLINKCHECK IN parm^.pathcheck) OR NeqN(ssid, raw[actdigi+(CALLLEN-2)], actdigi)) THEN
            ok:=TRUE;
            IF (ssid>ORD(NOT (NULLSSID IN parm^.pathcheck))) & (SENDTRACE IN parm^.pathcheck) THEN
              setSSID(raw[actdigi+(CALLLEN-1)], ssid-1);          (* dec(N) of WIDEn-N *)
              startpath:=actdigi;
            END;
            IF NOT (DOWNPATHALL IN parm^.pathcheck) THEN downpath:=actdigi+CALLLEN END;
          END;

IF show & ok THEN IO.WrStr(" via TRACEn-n "); END;

        END;

        IF NOT ok THEN
          IF NOT (NOVIAWIDEN IN parm^.pathcheck) 
          & Cmp(raw, actdigi, "WIDE") & (raw[actdigi+(CALLLEN-2)]=BLANKH)
          & ChkNN(ssid, raw[actdigi+(CALLLEN-3)])
          & ((NOUPLINKCHECK IN parm^.pathcheck) OR NeqN(ssid, raw[actdigi+(CALLLEN-3)], actdigi)) THEN
            ok:=TRUE;
            IF (raw[actdigi+(CALLLEN-3)]<>BLANKH) & (SENDWIDE IN parm^.pathcheck) THEN
              IF (NOCALLBEFOREWIDE IN parm^.pathcheck)
              OR NOT NeqN(ssid, raw[actdigi+(CALLLEN-3)], actdigi) THEN nodigicall:=TRUE END;   (* maybe repeatet before *)

              IF ssid>ORD(NOT (NULLSSID IN parm^.pathcheck)) THEN
                setSSID(raw[actdigi+(CALLLEN-1)], ssid-1);
                startpath:=actdigi; 
              ELSIF nodigicall THEN raw[actdigi+(CALLLEN-1)]:=CHR(ORD("0")*2+HBIT); (* WIDE* *) 
              END;
              IF nodigicall THEN startpath:=actdigi END;
            END;
            IF NOT (DOWNPATHALL IN parm^.pathcheck) THEN downpath:=actdigi+CALLLEN END;
          END;

IF show & ok THEN IO.WrStr(" via WIDEn-n " ); END;

        END;

IF show & NOT ok THEN IO.WrStr(" no source path " ); END;

      ELSIF show THEN IO.WrStr(" allready digipeated " );

      END;
    END;
  END; 

  IF duponly OR ok THEN
    hash:=Hash(raw, pathlen, inlen);
    t:=time();                                                          (* time in s *)
    IF parm^.timehash[hash]+MakeDupeTime(raw, pathlen, parm)<=t THEN    (* not a duplicate *)
      parm^.timehash[hash]:=t;

      IF duponly THEN                                                   (* dupfilter only *)
        outlen:=inlen+2;
        FOR i:=0 TO outlen-1 DO send[i]:=raw[i] END;

      ELSE                                                              (* digipeater *)
        i:=0;
        WHILE i<actdigi DO send[i]:=CAST(CHAR, CAST(SET8,raw[i])*SET8{1..7}); INC(i) END; (* copy from-to and clear address end bit *)

        IF NOT nodigicall THEN
          FOR j:=0 TO CALLLEN-1 DO send[i]:=parm^.digicall[j]; INC(i) END;    (* append new via digicall *)
          IF ssidroute>0 THEN
            send[i]:=CHR(ORD("W")*2); INC(i);
            send[i]:=CHR(ORD("I")*2); INC(i);
            send[i]:=CHR(ORD("D")*2); INC(i);
            send[i]:=CHR(ORD("E")*2); INC(i);
            send[i]:=CHR((ORD("0")+ssidroute)*2); INC(i);
            send[i]:=CHR(ORD(" ")*2); INC(i);
            send[i]:=CHR((ORD("0")+ssidroute)*2); INC(i);               (* no H bit set *)
          END;
        END;

        IF KILLWIDE IN parm^.pathcheck THEN killwide(startpath, downpath, raw) END;
        j:=startpath;                                                   (* append rest of path *)
        WHILE (j<downpath) & (i<CALLLEN*10) DO send[i]:=raw[j]; INC(i); INC(j) END; 
        send[i-1]:=CAST(CHAR, CAST(SET8, send[i-1])+SET8{0});           (* set address end bit *)

        FOR j:=pathlen TO inlen-1 DO send[i]:=raw[j]; INC(i); END;      (* append data field no crc *)
        AppCRC(send,i);
        outlen:=i+2;
      END;

    ELSIF show THEN IO.WrStr(" "); IO.WrCard(t-parm^.timehash[hash],1); IO.WrStr("s since same payload "); 
    END;

  END;
END Digi;




PROCEDURE GetIp(h:ARRAY OF CHAR; VAR ip:IPNUM; VAR port:UDPPORT):INTEGER;
VAR i, p, n:CARDINAL;
    ok:BOOLEAN;
BEGIN
  p:=0;
  h[HIGH(h)]:=0C;
  ip:=0;
  FOR i:=0 TO 4 DO
    n:=0;
    ok:=FALSE;
    WHILE (h[p]>="0") & (h[p]<="9") DO
      ok:=TRUE;
      n:=n*10+ORD(h[p])-ORD("0");
      INC(p);
    END;
    IF NOT ok THEN RETURN -1 END;
    IF i<3 THEN
      IF (h[p]<>".") OR (n>255) THEN RETURN -1 END;

      ip:=ip*256+n;
    ELSIF i=3 THEN
      ip:=ip*256+n;
      IF (h[p]<>":") OR (n>255) THEN RETURN -1 END;

    ELSIF n>65535 THEN RETURN -1 END;

    port:=n;
    INC(p);
  END;  
  RETURN 0
END GetIp;


PROCEDURE GetSec(h:ARRAY OF CHAR; VAR p, n:CARDINAL):INTEGER;
VAR ok:BOOLEAN;
BEGIN
  h[HIGH(h)]:=0C;
  n:=0;
  ok:=FALSE;
  WHILE (h[p]>="0") & (h[p]<="9") DO
    ok:=TRUE;
    n:=n*10+ORD(h[p])-ORD("0");
    INC(p);
  END;
  IF NOT ok THEN RETURN -1 END;
(*
IO.WrCard(n,10); IO.WrLn;
*)
  RETURN 0
END GetSec;




PROCEDURE MakeRawCall(VAR c:RAWCALL; s:ARRAY OF CHAR; j:CARDINAL);
VAR i, n:CARDINAL;
BEGIN
  i:=0;
  WHILE i<CALLLEN-1 DO
    IF (s[j]<>0C) & (s[j]<>"-") THEN c[i]:=CHR(ORD(s[j])*2); INC(j);
    ELSE c[i]:=BLANKH END; 
    INC(i);
  END;
  n:=0;
  IF s[j]="-" THEN
    INC(j);
    WHILE (s[j]>="0") & (s[j]<="9") DO n:=n*10 + ORD(s[j])-ORD("0"); INC(j) END;
  END;
  IF n>15 THEN Err("wrong SSID") END;
  IF s[j]="*" THEN c[CALLLEN-1]:=0C ELSE c[CALLLEN-1]:=CHR(n*2+(96+HBIT)) END;   (* set H bit *)
END MakeRawCall;


PROCEDURE Ackpath(h-:ARRAY OF CHAR);
BEGIN
  Assign(ackpath, ">");
  Append(ackpath, TOCALL);
  IF h[0]<>0C THEN
    Append(ackpath, ",");
    Append(ackpath, h);
  END;
  Append(ackpath, "::");
END Ackpath;

PROCEDURE getfix(VAR x:REAL; s-:ARRAY OF CHAR; VAR p:CARDINAL):BOOLEAN;
VAR i:CARDINAL;
    h:ARRAY[0..255] OF CHAR;
BEGIN
  i:=0;
  WHILE (s[p]>" ") & (s[p]<>"/") & (i<HIGH(h)) DO h[i]:=s[p]; INC(i); INC(p) END;
  h[i]:=0C;
  IF StrToFix(x, h) THEN RETURN TRUE END;
  RETURN FALSE
END getfix;


PROCEDURE parms;
VAR h                : ARRAY[0..4095] OF CHAR;
    err, actecho     : BOOLEAN;
    lasth            : CHAR;
    actsock          : pINSOCK;
    outsock, onext   : pOUTPORT;
    actpass          : SET256;
    actdigi          : pDIGIPARMS; 
    i, n, nold       : CARDINAL;
    actbeacon        : BEACON;
    user             : pMSGHASH; 
    actcall, callnext: pCALLS;
    actkm            : REAL;
    actpos           : POSITION;  
BEGIN

  msgusers:=NIL;
  actsock:=NIL;
  actcall:=NIL;
  err:=FALSE;
  show:=FALSE;
  Ackpath(DEFAULTACK);
  actkm:=0.0;

  LOOP
    NextArg(h);
    IF h[0]=0C THEN EXIT END;
    IF (h[0]="-") & (h[1]<>0C) & (h[2]=0C) THEN
      lasth:=h[1];
      IF lasth="a" THEN
        NextArg(h);
        IF h[0]="-" THEN h[0]:=0C END; 
        Ackpath(h);

      ELSIF (lasth="R") OR (lasth="M") THEN
        NextArg(h);
        actecho:=FALSE;
        actpass:=SET256{0..255};
        actdigi:=NIL;
        actcall:=NIL; 
        actbeacon.bintervall:=0;
        ALLOCATE(actsock, SIZE(actsock^));
        IF actsock=NIL THEN Err("out of memory") END;
        WITH actsock^ DO
          IF GetIp(h, fromip, bindport)<0 THEN Err("cannot open udp socket") END;
          fd:=udp.openudp();
          rawread:=lasth="R";
          outchain:=NIL;
          IF (fd>=0) & (udp.bindudp(fd, bindport)<0) THEN Err("cannot bind inport") END;
          next:=NIL;
        END;
        IF insocks<>NIL THEN actsock^.next:=insocks END;
        insocks:=actsock;

      ELSIF lasth="f" THEN
        NextArg(h);
        IF actsock=NIL THEN Err("need input -M or -R before -f") END;
        actpass:=SET256{};
        IF (h[0]<>cFILTDEL) & (h[0]<>cFILTPASS) THEN Err("pass or delete needed") END;
        i:=1;
        n:=0;
        nold:=256;
        LOOP
          IF i>=HIGH(h) THEN EXIT END;
          IF (h[i]>="0") & (h[i]<="9") THEN n:=n*10 + ORD(h[i]) - ORD("0");
          ELSE
            LOOP 
              IF (n>0) & (n<256) THEN INCL(actpass, n) END;
              IF n<=nold THEN EXIT END;
              DEC(n);
            END;
            nold:=256; 
            IF h[i]="-" THEN nold:=n ELSIF h[i]<>"," THEN EXIT END;
            n:=0;
          END;  
          INC(i);
        END;
        IF h[0]=cFILTDEL THEN actpass:=-actpass END;  

      ELSIF lasth="k" THEN
        NextArg(h);
        IF actsock=NIL THEN Err("need input -M or -R before -k") END;
        i:=0;
        IF NOT getfix(actpos.lat, h, i) THEN Err("latitude in deg") END;
        INC(i); 
        IF (h[i-1]<>"/") OR NOT getfix(actpos.long, h, i) THEN Err("longitude in deg") END;
        INC(i);
        IF (h[i-1]<>"/") OR NOT getfix(actkm, h, i) OR (actkm>=FLOAT(MAX(INTEGER))) THEN 
          Err("distance in km");
        END;

      ELSIF lasth="b" THEN
        NextArg(h);
        IF actsock=NIL THEN Err("need input -M or -R before -b") END;
        WITH actbeacon DO
          i:=0;
          IF (GetSec(h,i,n)>=0) & (h[i]=":") THEN 
            bintervall:=n;
            btime:=0;
            INC(i);
            FOR n:=0 TO HIGH(bfile) DO IF i<=HIGH(h) THEN bfile[n]:=h[i]; INC(i) END; END;
          ELSE Err("beacon format is time:file") END;
        END;

      ELSIF lasth="d" THEN
        NextArg(h);
        IF actsock=NIL THEN Err("need input -M or -R before -d") END;

        ALLOCATE(actdigi, SIZE(actdigi^));
        IF actdigi=NIL THEN Err("out of memory") END;
        WITH actdigi^ DO
          MakeRawCall(digicall, h, 0);
          IF (digicall[0]=0C) OR (digicall[CALLLEN-1]=0C) THEN Err("wrong digi callsign") END;
          FOR i:=0 TO HIGH(timehash) DO timehash[i]:=0 END;
          duptime:=DEFAULTDUPTIME;
          messagetime:=DEFAULTMESSAGETIME;
          pathcheck:=PATHSET{};
        END;

      ELSIF lasth="e" THEN actecho:=TRUE

      ELSIF (lasth="r") OR (lasth="m")  OR (lasth="c") THEN
        IF actsock=NIL THEN Err("need input -M or -R before -r or -m or -c") END;
        NextArg(h);

        ALLOCATE(outsock, SIZE(outsock^));
        IF outsock=NIL THEN Err("out of memory") END;
        WITH outsock^ DO
          IF GetIp(h, toip, toport)<0 THEN Err("wrong udp:port") END;
          aprspass:=actpass;
          echo:=actecho; 
          digiparm:=actdigi;
          rawwrite:=lasth="r";
          crlfwrite:=lasth="c";
          beacon:=actbeacon;
          actbeacon.bintervall:=0;
          passnoUI:=FALSE;
          next:=NIL;
          filtercalls:=actcall;
          mypos.lat :=actpos.lat*RAD;
          mypos.long:=actpos.long*RAD;
          maxkm:=TRUNC(actkm);
        END;
        actdigi:=NIL;
        onext:=actsock^.outchain;
        IF onext=NIL THEN actsock^.outchain:=outsock;
        ELSE 
          WHILE onext^.next<>NIL DO onext:=onext^.next END;
          onext^.next:=outsock;
        END;

      ELSIF lasth="h" THEN
        IO.WrLn;
        IO.WrStrLn(" -a <paths>     user message ack path eg. WIDE2-2 or - for no path");
        IO.WrStrLn(" -b <s>:<file>  enable beacon every s(econds) path and text from <file>");
        IO.WrStrLn(" -c <ip>:<port> send text monitor udp frame with cr lf");
        IO.WrStrLn(" -d <call>      digipeater enable (and dupe filter) call");
        IO.WrStrLn(" -d -           dupe filter without data modification");
        IO.WrStrLn(" -e             echo last (filtert) output");
        IO.WrStrLn(" -f <filterparm>  'p<x>,<x>...' pass UI frames with first char (-f p58,110)");
        IO.WrStrLn("                  'd<x>,<x>...' pass UI frames with not first char (-f d32,65-79)");
        IO.WrStrLn(" -h             this");
        IO.WrStrLn(" -k <deg>/<deg>/<km> distance filter, center/radius -k 48.2/-13.5/100");
        IO.WrStrLn("                -k 0/0/20000 remove all (not user msg) with no position data");
        IO.WrStrLn(" -M <ip>:<port> read text monitor udp frame");
        IO.WrStrLn(" -m <ip>:<port> send text monitor udp frame 0 terminated");
        IO.WrStrLn(" -p <n>,<...>   -p 7,8 igate friendly digi relaying all direct heared");
        IO.WrStrLn("                -p 5,6,7,8,9 first hop digi, -p 3,4 (noisy) last hop digi");
        IO.WrStrLn("                -p 0,1,3,4,5,6,7,8,9,14,16 original, noisy, path loosing ...");
        IO.WrStrLn("                0..2 extend SSID to via 'digicall* WIDEn-n' else via digicall*");
        IO.WrStrLn("                0,1,2 only decrement destination SSID (loose path, until -0)");
        IO.WrStrLn("                3 allow repeatet before (mostly with wrong path trace)");
        IO.WrStrLn("                4 no uplink check for 'looks like direct heared'");
        IO.WrStrLn("                  (noisy, wrong path trace possible)");
        IO.WrStrLn("                5 resend TRACEn-(N-1), 6 resend WIDEn-(N-1)");
        IO.WrStrLn("                  so frames may be relayed again by loss of downlink trace");
        IO.WrStrLn("                7,8,9 append remaining digi path after via digicall, RELAY, WIDE");
        IO.WrStrLn("                  so frames may be relayed again by loss of downlink trace");
        IO.WrStrLn("                10, 11, 12, 13 switch off via digicall, RELAY, TRACE, WIDE");
        IO.WrStrLn("                14 insert not digicall on direct heared before WIDEn-N,");
        IO.WrStrLn("                   as others do, your digi is hidden, and path is shown wrong");
        IO.WrStrLn("                15 no relaying by destination-SSID loosing most efficient routing");
        IO.WrStrLn("                16 send n-0 without repeated flag");
        IO.WrStrLn("                17 remove all WIDE from downlink path");
        IO.WrStrLn(" -R <ip>:<port> read raw axudp frame, 0 ip read from all (-R 0.0.0.0:2000)");
        IO.WrStrLn(" -r <ip>:<port> send raw axudp frame");
        IO.WrStrLn(" -t <s>,<s>     dupe filter time in seconds (all types , user messages)");
        IO.WrStrLn("                -t 1740,28 29min not same beacon, 28s for retrying user message)");
        IO.WrStrLn(" -u <call>:<file> global option, receive & ack usermessages to call store in file");
        IO.WrStrLn(" -v             show frames and analytics on stdout");
        IO.WrStrLn(" -x <call>{,<call>} delete frames with call in a address field, -x TCPIP,UID***-*");
        IO.WrStrLn("udpbox -v -M 0.0.0.0:9200 -d MYCALL-10 -p 0,1,7 -t 1800,28 -r 192.168.1.24:9400");
        IO.WrLn;

        HALT

      ELSIF lasth="t" THEN
        IF actdigi=NIL THEN Err("need -d before -t") END;
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN 
          actdigi^.duptime:=n;
          INC(i);
          IF (h[i-1]=",") & (GetSec(h,i,n)>=0) THEN actdigi^.messagetime:=n END; 
        END;

      ELSIF lasth="p" THEN
        IF actdigi=NIL THEN Err("need -d before -p") END;
        NextArg(h);
        i:=0;
        WHILE GetSec(h,i,n)>=0 DO 
          IF n<31 THEN INCL(actdigi^.pathcheck, n) END;
          IF h[i]="," THEN INC(i) END;
        END;

      ELSIF lasth="u" THEN
        NextArg(h);
        ALLOCATE(user, SIZE(user^));
        IF user=NIL THEN Err("out of memory") END;
        WITH user^ DO
          wpos:=0;
          msgfile[0]:=0C;
          FOR i:=0 TO HIGH(hash) DO hash[i].ackcnt:=0 END;
          i:=0;
          n:=0;
          WHILE (n<=HIGH(usercall)) & (h[i]<>0C) & (h[i]<>":") DO 
            usercall[n]:=h[i]; INC(n); INC(i);
          END;
          WHILE n<=HIGH(usercall) DO usercall[n]:=" "; INC(n) END;
          IF h[i]<>0C THEN
            INC(i);
            n:=0;
            WHILE (n<=HIGH(msgfile)) & (h[i]<>0C) DO msgfile[n]:=h[i]; INC(n); INC(i) END;
          END;
          next:=NIL;
        END;
        IF msgusers<>NIL THEN user^.next:=msgusers END;  
        msgusers:=user;

      ELSIF lasth="v" THEN
        show:=TRUE;
 
      ELSIF lasth="x" THEN
        NextArg(h);
        IF actsock=NIL THEN Err("need input -M or -R before -x") END;

        i:=0;
        LOOP
          ALLOCATE(callnext, SIZE(callnext^));
          IF callnext=NIL THEN Err("out of memory") END;
          MakeRawCall(callnext^.call, h, i);
          callnext^.next:=actcall;
          actcall:=callnext;
          WHILE h[i]<>"," DO
            IF (i>=HIGH(h)) OR (h[i]<=" ") THEN EXIT END;
            INC(i);        
          END;
          INC(i);
        END;

      ELSE err:=TRUE END;
      h[0]:=0C;
    ELSE err:=TRUE END;
    IF err THEN EXIT END;
  END;
  IF err THEN IO.WrStr(">"); IO.WrStr(h); IO.WrStrLn("< use -h"); HALT END;

END parms;

PROCEDURE showpip(ip:IPNUM; port:UDPPORT);
BEGIN
  IO.WrCard(ip DIV 1000000H,1); IO.WrChar(".");
  IO.WrCard(ip DIV 10000H MOD 100H ,1); IO.WrChar(".");
  IO.WrCard(ip DIV 100H MOD 100H ,1); IO.WrChar(".");
  IO.WrCard(ip MOD 100H ,1); IO.WrChar(":");
  IO.WrCard(port, 1);
END showpip;

(*
PROCEDURE showstr(s-:ARRAY OF CHAR);

  PROCEDURE Hex(b:SET8):CHAR;
  VAR d:CARDINAL;
  BEGIN
    d:=CAST(CARDINAL, b*SET8{0..3});
    IF d>9 THEN INC(d, ORD("A")-10-ORD("0")) END;
    RETURN CHR(d+ORD("0"))  
  END Hex;

VAR i,j:CARDINAL;
    h:ARRAY[0..1023] OF CHAR; 
BEGIN
  i:=0;
  j:=0;
  WHILE (i<=HIGH(s)) & (s[i]<>0C) & (j<HIGH(h)-5) DO
    IF s[i]<" " THEN 
      h[j]:="<"; INC(j);
      h[j]:=Hex(SHIFT(CAST(SET8, s[i]), -4)); INC(j);
      h[j]:=Hex(CAST(SET8, s[i])); INC(j);
      h[j]:=">";
    ELSE h[j]:=s[i] END;
    INC(i);
    INC(j);
  END;
  h[j]:=0C;
  IO.WrStrLn(h); 
END showstr;
*)

PROCEDURE cpraw(VAR in, out:ARRAY OF CHAR; VAR len:INTEGER);
VAR i,n,e:INTEGER;
    c:CHAR;
    h:BOOLEAN;

  PROCEDURE showhex(s-:ARRAY OF CHAR);
  VAR i:INTEGER;
  BEGIN
IF show THEN
 IO.WrLn;
 IO.WrStrLn(s);
 FOR i:=0 TO len-1 DO IO.WrHex(ORD(in[i]),3) END;
 IO.WrLn;
 FOR i:=0 TO e-1 DO
   n:=ORD(in[i]) DIV 2;
   IF n<ORD(" ") THEN IO.WrChar("<") ;IO.WrHex(ORD(n),1); IO.WrChar(">")
   ELSE IO.WrChar(CHR(n)) END;
   IF i MOD 7=6 THEN IO.WrStr(",") END;
 END;
 IO.WrLn;
END;

  END showhex;

BEGIN
  e:=0;
  FOR i:=0 TO len-1 DO
    c:=in[i];
    out[i]:=c;
    IF (e=0) & ODD(ORD(c)) THEN e:=i+1 END;
  END;

  IF (VAL(CARDINAL,e) MOD CALLLEN<>0) OR (e<CALLLEN*2) OR (e>CALLLEN*10) THEN
    showhex(" bad raw format, no address end found");
    len:=0;
  ELSE 
    h:=TRUE;
    FOR i:=CALLLEN*3-1 TO e-1 BY CALLLEN DO
      IF ORD(in[i])>=128 THEN
        IF NOT h THEN
          showhex(" bad H bit in raw frame"); 
          len:=0;
        END; 
        h:=TRUE;
      ELSE h:=FALSE END;
    END;
  END;
END cpraw;

PROCEDURE beacon(insock:pINSOCK; VAR buf:ARRAY OF CHAR; VAR len:INTEGER; VAR outsock:pOUTPORT);
VAR i:INTEGER;
    f:File;
    fb:ARRAY[0..1023] OF CHAR;
    t:TIME;
BEGIN
  len:=0;
  outsock:=insock^.outchain;
  LOOP
    IF outsock=NIL THEN len:=0; EXIT END;
    WITH outsock^.beacon DO
      t:=time();
      IF (bintervall>0) & (bfile[0]<>0C) & (btime<=t) THEN
        INC(btime, bintervall);
        IF btime<=t THEN btime:=t+bintervall END;
        f:=OpenMode(bfile, oRDONLY);
        IF f>=0 THEN
          len:=RdBin(f, fb, SIZE(fb)-1);
          Close(f);
          i:=0;
          WHILE (i<len) & (fb[i]>=" ") DO INC(i) END;
          fb[i]:=0C;
(*
IF show THEN IO.WrStrLn(fb) END;
*)
          IF i>0 THEN mon2raw(fb, buf, len) END;

IF show & (len=0) THEN IO.WrLn; IO.WrStrLn("bad beacon format "); END;
          EXIT
        ELSE IO.WrStrLn("beacon file open error") END;
      END;
      outsock:=outsock^.next;
    END; 
  END;
END beacon;

PROCEDURE sendack(buf:ARRAY OF CHAR; VAR len:INTEGER; fromsock:pINSOCK);
CONST ACKTIME=30;

VAR m:INTEGER;
    i,j:CARDINAL;
    user:pMSGHASH;
    fb:ARRAY[0..255] OF CHAR;
    t:TIME;
BEGIN
  user:=msgusers;
  t:=time();
  WHILE user<>NIL DO
    len:=0;
    WITH user^ DO
      FOR m:=0 TO HIGH(hash) DO
        WITH hash[m] DO
          IF (ackcnt>0) & (acktime<t) & (fromsock=source) THEN
            DEC(ackcnt);
            acktime:=t+ACKTIME; 

            j:=0;
            i:=0;
            WHILE (i<=HIGH(usercall)) & (usercall[i]>" ") DO 
              fb[j]:=usercall[i];
              INC(j);
              INC(i);
            END;

            i:=0;
            WHILE ackpath[i]>" " DO fb[j]:=ackpath[i]; INC(j); INC(i); END;

            FOR i:=0 TO 8 DO fb[j]:=froms[i]; INC(j); END;
            fb[j]:=":";
            INC(j); 

            i:=0;
            WHILE ACKMSG[i]>" " DO fb[j]:=ACKMSG[i]; INC(j); INC(i); END;
(*
IO.WrLn; IO.WrStr("    <"); IO.WrStr(hash[m].acks); IO.WrStrLn(">");
*)
            i:=0;
            WHILE acks[i]>" " DO fb[j]:=acks[i]; INC(j); INC(i); END;

            fb[j]:=0C;
            mon2raw(fb, buf, len);
IF show & (len=0) THEN IO.WrStr(fb); IO.WrStrLn(" message ack path wrong") END;


            RETURN
          END;
        END;
      END;
      user:=next;
    END;
  END;
END sendack;

VAR maxsock               : INTEGER;
    ibuf, rawbuf, rawout, workraw : ARRAY[0..MAXLEN-1] OF CHAR;
    mbuf                  : ARRAY[0..511] OF CHAR;
    inlen, outlen, res    : INTEGER;
    monlen                : CARDINAL;
    rset, inset           : FdSet;
    actsock               : pINSOCK;
    outsock, isbeacon     : pOUTPORT;
    tv                    : TimeVal;
    nobeacon              : BOOLEAN;


BEGIN
  insocks:=NIL;
  Gencrctab;
  parms;


  FD_ZERO(inset);
  maxsock:=0;
  actsock:=insocks;
  WHILE actsock<>NIL DO
    WITH actsock^ DO  
      IF fd>=0 THEN 
        FD_SET(fd, inset);
        IF fd>maxsock THEN maxsock:=fd END; 
      END;
      actsock:=next;
    END;
  END;


  LOOP
    rset:=inset;
    tv.tv_usec:=0;
    tv.tv_sec:=1;
    IF select(maxsock+1, ADR(rset), NIL, NIL, ADR(tv))>=0 THEN
      actsock:=insocks;
      WHILE actsock<>NIL DO  
        nobeacon:=(actsock^.fd>=0) & FD_ISSET(actsock^.fd, rset);
        IF nobeacon THEN
          inlen:=getudp(actsock^.fd, ibuf, actsock^.fromip, actsock^.rawread);
          IF inlen>0 THEN
            IF actsock^.rawread THEN cpraw(ibuf, rawbuf, inlen);
            ELSE
              IF inlen<=HIGH(ibuf) THEN ibuf[inlen]:=0C END;
              mon2raw(ibuf, rawbuf, inlen);
              IF show & (inlen=0) THEN IO.WrStrLn("bad mon format "); END;
            END;
          END; 
          isbeacon:=NIL;
        ELSE 
          beacon(actsock, rawbuf, inlen, isbeacon);
          IF isbeacon=NIL THEN sendack(rawbuf, inlen, actsock) END;
        END;
 
        IF inlen>=2 THEN
          IF show THEN
            raw2mon(rawbuf, mbuf, inlen-2, monlen);
            IO.WrLn;
            showpip(showip, showport);
            IO.WrStr("("); IO.WrCard(inlen,1); IO.WrStr(")"); 
            IO.WrChar(":");
            CtrlHex(mbuf);
            IO.WrStrLn(mbuf);
          END;

          outsock:=actsock^.outchain;
          outlen:=0;
          WHILE outsock<>NIL DO
            IF show THEN IO.WrStr(" tx: "); showpip(outsock^.toip, outsock^.toport); END;
            workraw:=rawbuf;
            IF ((isbeacon=NIL) OR (isbeacon=outsock) OR outsock^.echo) 
            & Filter(workraw, inlen, outsock, actsock) THEN

              IF outsock^.digiparm<>NIL THEN 
                Digi(workraw, rawout, inlen, outlen, outsock^.digiparm, NOT nobeacon);
                IF show & (outlen>0) THEN IO.WrStr(" digi"); END;
              ELSIF NOT outsock^.echo THEN
                rawout:=workraw;
                outlen:=inlen;
              END;                                                 (* else use last filtert *)

              IF outlen>0 THEN
                IF outsock^.rawwrite THEN
                  res:=udp.udpsend(actsock^.fd, rawout, outlen, outsock^.toport, outsock^.toip);
                  IF show THEN IO.WrStrLn(" raw") END;
                ELSE
                  raw2mon(rawout, mbuf, outlen-2, monlen);
                  IF monlen>0 THEN
                    IF outsock^.crlfwrite THEN 
                      mbuf[monlen-1]:=CR; mbuf[monlen]:=LF; INC(monlen);
                    END; 
                    res:=udp.udpsend(actsock^.fd, mbuf, monlen, outsock^.toport, outsock^.toip);
                    IF show THEN IO.WrStrLn(" mon") END;
                  END;
                END;
              ELSIF show THEN IO.WrStrLn(" no tx") END;
            ELSIF show THEN IO.WrStrLn(" deleted") END;
            outsock:=outsock^.next;
          END;
        END;  
        actsock:=actsock^.next;
      END;
    END;
  END;
END udpbox.


(*
      -->-----------------         -->--------
      !                  !         !         !
----- !   -----   -----  !   ----- !   ----- !         -----    -----  -----
!-R ! !   !-d !   !-r !  !   !-d ! !   !-r ! ! -----   !-d !    !-r !  !-R ! 
!-M !--->-!-f !->-!-m !  -->-!-f !--->-!-m ! --!-e !->-!-f !-->-!-m !  !-M !-> ...
-----     !-p !   !-c !      !-p !     !-c !   -----   !-p !    !-c !  -----
          !-x !   -----      !-x !     -----           !-x !    -----
          !-b !              !-b !                     !-b !
          -----              -----                     -----
receive   filter1 send       filter2   send            filter3  send

*)