<*+M2EXTENSIONS *>
<*-CHECKDIV *>
<*-CHECKRANGE *>
<*-COVERFLOW *>
<*-IOVERFLOW*>
<*+PROCINLINE*>
<*+NOPTRALIAS*>
<*-GENHISTORY*>
<*-CHECKNIL *>
<*-GENDEBUG*>
<*-LINENO*>
<*-CHECKINDEX*>
<*-CHECKSET*>
<*CPU="PENTIUM"*>

MODULE udpgate; (* axudp in/out tcpip out aprs-is gateway by OE5DXL *)

IMPORT IO, udp, tcp;
FROM FdSet IMPORT FdSet, FD_ZERO, FD_SET, FD_ISSET, TimeVal;
FROM mlib IMPORT select;
FROM SYSTEM IMPORT CAST, SHIFT, ADR, CARD8, FILL;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM Lib IMPORT NextArg;
FROM TimeConv IMPORT time; 
FROM FIO IMPORT OpenMode, Close, oRDONLY, oAPPEND, oWRONLY, Create, WrBin, RdBin;
FROM aprspos IMPORT POSITION, RAD, posvalid, distance, GetPos;
FROM aprsstr IMPORT TIME ,Assign, Append, Length, IntToStr, FixToStr, StrToFix,
     StrCmp, TimeToStr, DateToStr, CtrlHex;


CONST CALLLEN=7;
      HASHSIZE=65536;

<* IF __GEN_C__ THEN *>
      VERS="udpgate(c) 0.1";
<* ELSE *>
      VERS="udpgate 0.1";
<* END *>

      HTTPTIMEOUT=60;
      UDPSHOWTIME=600;                               (* show udp in html *)

TYPE  UDPPORT=CARDINAL;
      IPNUM=CARDINAL;
      SET8=SET OF [0..7];
      MONCALL=ARRAY[0..9] OF CHAR;
      FILENAME=ARRAY[0..1023] OF CHAR;
      FRAMEBUF=ARRAY[0..256+3+11*10] OF CHAR;


      BEACON=RECORD
               bintervall: TIME;
               bfile     : FILENAME;
               btime     : TIME;
             END;

(*
      POSITION=RECORD
                 long,
                 lat:REAL;
               END;   
*)

      POSCALL=RECORD
                call:MONCALL;
                typ:CHAR;
                pos:POSITION;
              END;   
       

      FILTERS=RECORD
                typ   :CHAR;
                base,
                edge  :POSITION;
                radius:REAL;
              END;
 
      pTCPSOCK=POINTER TO TCPSOCK;
      TCPSOCK=RECORD
               next    : pTCPSOCK;
               fd      : INTEGER;
               beacont, 
               connt   : TIME;
               valid   : BOOLEAN; 
               service : CHAR;
               ipnum   : ARRAY[0..63] OF CHAR;
               port    : ARRAY[0..5] OF CHAR;
               user    : POSCALL;
               vers    : ARRAY[0..20] OF CHAR; 
               txframes, txbytes, rxframes, rxbytes:CARDINAL;
               filters : FILTERS;
               rpos, 
               tlen    : INTEGER;
               rbuf, 
               tbuf    : FRAMEBUF; 
             END;

CONST 
      POLYNOM=BITSET{3,10,15};
      CRCINIT=BITSET{0..15};
      CRCRESULT=BITSET(40715);
      CR=015C;
      LF=012C;
      cUSERMESSAGE=":";
      cISGATEWAY="G";
      cISSERVER="S";
      cISWWW="W";

VAR CRCL, CRCH            : ARRAY[0..255] OF SET8;
    show, keepconn        : BOOLEAN;
    tcpsocks              : pTCPSOCK;
    showip1               : IPNUM;
    showport1             : UDPPORT;
    systime               : TIME;

    ungate                : ARRAY[0..5] OF ARRAY[0..6] OF CHAR;
    timehash              : ARRAY[0..HASHSIZE-1] OF TIME;
    dupetime, uptime      : TIME;
    netbeaconfn,
    logframename          : FILENAME;
    netbeaconintervall, connecttime: TIME;
    maxusers              : CARDINAL;
    logframes             : INTEGER;
    showid, servercall    : MONCALL;
    home                  : POSITION;
    passwd                : ARRAY[0..5] OF CHAR;
    serverrangefilter     : ARRAY[0..255] OF CHAR;
    tcpbindport, 
    wwwbindport           : ARRAY[0..5] OF CHAR;
    udpsock: RECORD 
               fd       : INTEGER;
               rawread  : BOOLEAN;
               fromip   : IPNUM;
               bindport : UDPPORT;
               laststat : CARDINAL;
               stat:ARRAY[0..15] OF RECORD
                 uip               : IPNUM;
                 uport             : UDPPORT;
                 txframes, txbytes,
                 rxframes, rxbytes : CARDINAL;
                 utime, dtime      : TIME;
               END;
             END;

    gateways:ARRAY[0..20] OF RECORD
                               url:ARRAY[0..255] OF CHAR;
                               port:ARRAY[0..5] OF CHAR;
                               lasttry:TIME;
                             END;  


PROCEDURE Err(text-:ARRAY OF CHAR);
BEGIN
  IO.WrStr(text); IO.WrStrLn(" error abort");
  HALT
END Err;


(*
PROCEDURE rad(w:REAL):REAL;
BEGIN RETURN w*(PI2/360.0) END rad;


PROCEDURE posvalid(pos-:POSITION):BOOLEAN;
BEGIN RETURN (pos.lat<>0.0) OR (pos.long<>0.0) END posvalid;

PROCEDURE distance(home,dist:POSITION):REAL;
CONST EARTH=40024.0/PI2;
(*
PROCEDURE sqr(x:REAL):REAL; BEGIN RETURN x*x END sqr;
*)
VAR h:LONGREAL;
BEGIN
(*
IO.WrStr(" pyth="); 
IO.WrFixed(EARTH*sqrt(sqr(home.lat-dist.lat)+sqr((dist.long-home.long)*cos(home.lat))), 1,5); 
*)
  h:=ABS(dist.long-home.long);
  IF (h=0.0) & (dist.lat=home.lat) THEN RETURN 0.0
  ELSE
    IF h>PI2 THEN h:=PI2-h END;
    h:=sin(dist.lat)*sin(home.lat) + cos(dist.lat)*cos(home.lat)*cos(h);
    IF ABS(h)>=1.0 THEN RETURN 0.0 END;
    RETURN 6370.0*arccos(h)
  END;
(*
EXCEPT                  (* EXCEPT + procinline compiles to junk *)

  IO.WrLn; IO.WrStrLn(" rechenfehler ");
  RETURN 0.5;
*)
END distance;


PROCEDURE azimuth(home,dist:POSITION):CARDINAL;
VAR h:INTEGER;
    ldiff:REAL;
BEGIN
  ldiff:=dist.long-home.long;
  IF (ldiff=0.0) OR (cos(home.lat)=0.0) OR (cos(dist.lat)=0.0) THEN
    IF home.lat<=dist.lat THEN RETURN 0 ELSE RETURN 180 END;
  ELSE
    h:=round(360.0/PI2*arctan(cos(home.lat)*((tan(home.lat)*cos(ldiff)-tan(dist.lat))/sin(ldiff))));
    IF ldiff<0.0 THEN RETURN h+270 ELSE RETURN h+90 END;
  END;
END azimuth;



PROCEDURE GetPos(VAR pos:POSITION; buf-:ARRAY OF CHAR; micedest, payload:CARDINAL);

  PROCEDURE dig(VAR s:REAL; c:CHAR; mul:REAL):BOOLEAN;
  BEGIN
(*
IO.WrStr("  D<");IO.WrChar(c);IO.WrStr(">  ");
*)
    IF c=" " THEN RETURN TRUE END;                     (* ambiguity *)
    IF (c<"0") OR (c>"9") THEN RETURN FALSE END;
    s:=s + FLOAT(ORD(c)-ORD("0"))*mul;
    RETURN TRUE
  END dig;

  PROCEDURE r91(VAR s:REAL; c:CHAR; mul:REAL):BOOLEAN;
  BEGIN
    IF (c<CHR(33)) OR (c>CHR(33+91)) THEN RETURN FALSE END;
    s:=s + FLOAT(ORD(c)-33)*mul;
    RETURN TRUE
  END r91;

  PROCEDURE mic(VAR s:REAL; c:CHAR; mul:REAL):BOOLEAN;
  VAR n:CARDINAL;
  BEGIN
(*
IO.WrStr("  D<"); IO.WrChar(c); IO.WrStr("> ");
*)
    IF  (c>="0") & (c<="9") THEN n:=ORD(c)-ORD("0")
    ELSIF (c>="A") & (c<="J") THEN n:=ORD(c)-ORD("A")
    ELSIF (c="K") OR (c="L") OR (c="Z") THEN n:=0
    ELSIF (c>="P") & (c<="Y") THEN n:=ORD(c)-ORD("P")
    ELSE RETURN FALSE END;
    s:=s + FLOAT(n)*mul;
    RETURN TRUE
  END mic;

  PROCEDURE bit5(c:CHAR):BOOLEAN;
  BEGIN RETURN ODD(ORD(c) DIV 32) OR (c="L") END bit5;       (* L is wildcard *)

  PROCEDURE komma(VAR p:CARDINAL);
  BEGIN WHILE (p<HIGH(buf)) & (buf[p]<>0C) & (buf[p]<>",") DO INC(p) END; INC(p) END komma;

  PROCEDURE ns(c:CHAR):BOOLEAN;
  BEGIN c:=CAP(c); RETURN (c="N") OR (c="S") END ns;

  PROCEDURE ew(c:CHAR):BOOLEAN;
  BEGIN c:=CAP(c); RETURN (c="E") OR (c="W") END ew;



VAR i,j,len,n:CARDINAL;
    c:CHAR;
    ok:BOOLEAN;

BEGIN
  len:=payload;
(*
IO.WrStr(" index="); IO.WrCard(len, 1); IO.WrLn;
*)
  WHILE (len<HIGH(buf)) & (buf[len]<>0C) DO INC(len) END;

  c:=buf[payload];
  IF (payload+3<len) & (micedest>0) 
  & ((c=CHR(01CH)) OR (c=CHR(01DH)) OR (c=CHR(027H)) OR (c=CHR(060H))) THEN (* mic-e *)
(*
IO.WrLn; IO.WrStr("   mice<");
FOR i:=0 TO 5 DO IO.WrChar(buf[i+micedest]) END;
IO.WrStr(">");
IO.WrStr("  payload<");
i:=payload;
IO.WrHex(ORD(buf[i]), 3); IO.WrStr("H ");
WHILE (i<HIGH(buf)) & (buf[i]<>0C) DO IO.WrChar(buf[i]); INC(i); END;
IO.WrStrLn(">");
*)
    pos.lat:=0.0;
    i:=micedest;
    ok:=TRUE;
            IF NOT mic(pos.lat, buf[i], 10.0*RAD) THEN ok:=FALSE END;
    INC(i); IF NOT mic(pos.lat, buf[i], 1.0*RAD) THEN ok:=FALSE END;
    INC(i); IF NOT mic(pos.lat, buf[i], 10.0/60.0*RAD) THEN ok:=FALSE END;
    INC(i); IF NOT mic(pos.lat, buf[i], 1.0/60.0*RAD) THEN ok:=FALSE END;
    INC(i); IF NOT mic(pos.lat, buf[i], 0.1/60.0*RAD) THEN ok:=FALSE END;
    INC(i); IF NOT mic(pos.lat, buf[i], 0.01/60.0*RAD) THEN ok:=FALSE END;
    IF bit5(buf[micedest+3]) THEN pos.lat:=-pos.lat END;   (* south *)

    n:=ORD(buf[payload+1]);                                    (* long degrees *)
    IF n>=28 THEN
      DEC(n, 28);
      IF NOT bit5(buf[micedest+4]) THEN INC(n, 100) END; 
      IF (n>=180) & (n<=189) THEN DEC(n, 80)
      ELSIF (n>=190) & (n<=199) THEN DEC(n, 190) END;
    ELSE ok:=FALSE END;
    pos.long:=FLOAT(n)*RAD;

    n:=ORD(buf[payload+2]);                                    (* long min *)
    IF n>=28 THEN
      DEC(n, 28);
      IF n>=60 THEN DEC(n, 60) END;
    ELSE ok:=FALSE END;
    pos.long:=pos.long+FLOAT(n)*(RAD/60.0);


    n:=ORD(buf[payload+3]);                                    (* long min/100 *)
    IF n>=28 THEN pos.long:=pos.long+FLOAT(n-28)*(RAD/6000.0);
    ELSE ok:=FALSE END;

    IF bit5(buf[micedest+5]) THEN pos.long:=-pos.long END;   (* east *)
(*
IO.WrStr(" long="); IO.WrFixed(pos.long/RAD, 4,10); IO.WrLn;
*)

  ELSIF c="$" THEN                       (* gps 4806.9409,N,01134.6219,E *)
    ok:=FALSE;
    IF (buf[payload+1]="G") & (buf[payload+2]="P") THEN
      i:=payload+7;
      IF (buf[payload+3]="G") & (buf[payload+4]="G") & (buf[payload+5]="A") THEN 
        komma(i);
        ok:=TRUE;
      ELSIF (buf[payload+3]="R") & (buf[payload+4]="M") & (buf[payload+5]="C") THEN 
        komma(i);
        komma(i);
        ok:=TRUE;
      ELSIF (buf[payload+3]="G") & (buf[payload+4]="L") & (buf[payload+5]="L") THEN 
        ok:=TRUE;
      END;

      pos.lat:=0.0;
               IF NOT dig(pos.lat, buf[i], RAD*10.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.lat, buf[i], RAD) THEN ok:=FALSE END;    
      INC(i);  IF NOT dig(pos.lat, buf[i], RAD/6.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.lat, buf[i], RAD/60.0) THEN ok:=FALSE END;
      INC(i,2);IF NOT dig(pos.lat, buf[i], RAD/600.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.lat, buf[i], RAD/6000.0) THEN ok:=FALSE END;
      komma(i);
      IF buf[i]="S" THEN pos.lat:=-pos.lat END;
      komma(i);

      pos.long:=0.0;
               IF NOT dig(pos.long, buf[i], RAD*100.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.long, buf[i], RAD*10.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.long, buf[i], RAD) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.long, buf[i], RAD/6.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.long, buf[i], RAD/60.0) THEN ok:=FALSE END;
      INC(i,2);IF NOT dig(pos.long, buf[i], RAD/600.0) THEN ok:=FALSE END;
      INC(i);  IF NOT dig(pos.long, buf[i], RAD/6000.0) THEN ok:=FALSE END;
      komma(i);
      IF buf[i]="E" THEN pos.long:=-pos.long END;
    END;

  ELSE
(* !4915.10N/01402.20E& *)
(* xnnnn.nnNxnnnnn.nnEx *)
    ok:=FALSE;
    pos.lat:=0.0;
    pos.long:=0.0;
    i:=0; 
    IF (buf[payload]="!") OR (buf[payload]="=") THEN i:=payload+1
    ELSIF (buf[payload]="/") OR (buf[payload]="@") THEN i:=payload+8    (* skip time *)
    ELSIF buf[payload]=";" THEN i:=payload+18                           (* skip object *)
    ELSIF buf[payload]=")" THEN                                         (* skip item *)
      i:=payload+4; 
      WHILE (i<len) & (buf[i]<>"|") & (buf[i]<>"_") DO INC(i) END;
    END;

    IF i>0 THEN
      IF (buf[i]>="0") & (buf[i]<="9") THEN
        IF (i+17<=len)  & (buf[i+4]=".") & (buf[i+14]=".") 
        & ns(buf[i+7]) & ew(buf[i+17]) THEN                            (* not compressed *)
          ok:=TRUE;
                    IF NOT dig(pos.lat, buf[i], 10.0*RAD) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.lat, buf[i], 1.0*RAD) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.lat, buf[i], 10.0*RAD/60.0) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.lat, buf[i], 1.0*RAD/60.0) THEN ok:=FALSE END;
          INC(i,2); IF NOT dig(pos.lat, buf[i], 0.1*RAD/60.0) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.lat, buf[i], 0.01*RAD/60.0) THEN ok:=FALSE END;
          INC(i);   IF CAP(buf[i])="S" THEN pos.lat:=-pos.lat
                    ELSIF CAP(buf[i])<>"N" THEN ok:=FALSE END;

          INC(i,2); IF NOT dig(pos.long, buf[i], 100.0*RAD) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.long, buf[i], 10.0*RAD) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.long, buf[i], 1.0*RAD) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.long, buf[i], 10.0*RAD/60.0) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.long, buf[i], 1.0*RAD/60.0) THEN ok:=FALSE END;
          INC(i,2); IF NOT dig(pos.long, buf[i], 0.1*RAD/60.0) THEN ok:=FALSE END;
          INC(i);   IF NOT dig(pos.long, buf[i], 0.01*RAD/60.0) THEN ok:=FALSE END;
          INC(i);   IF CAP(buf[i])="E" THEN pos.long:=-pos.long
          ELSIF CAP(buf[i])<>"W" THEN ok:=FALSE END;
        END;

      ELSE  
        IF i+13<=len THEN                                                  (* compressed pos*)
          ok:=TRUE;
          INC(i); IF NOT r91(pos.lat, buf[i], 91.0*91.0*91.0) THEN ok:=FALSE END;      
          INC(i); IF NOT r91(pos.lat, buf[i], 91.0*91.0) THEN ok:=FALSE END;
          INC(i); IF NOT r91(pos.lat, buf[i], 91.0) THEN ok:=FALSE END;
          INC(i); IF NOT r91(pos.lat, buf[i], 1.0) THEN ok:=FALSE END;
          pos.lat:=90.0*RAD - pos.lat*(RAD/380926.0);
          INC(i); IF NOT r91(pos.long, buf[i], 91.0*91.0*91.0) THEN ok:=FALSE END;
          INC(i); IF NOT r91(pos.long, buf[i], 91.0*91.0) THEN ok:=FALSE END;
          INC(i); IF NOT r91(pos.long, buf[i], 91.0) THEN ok:=FALSE END;
          INC(i); IF NOT r91(pos.long, buf[i], 1.0) THEN ok:=FALSE END;
          pos.long:=180.0*RAD - pos.long*(RAD/190463.0);
        END;
      END;  
    END;
    
  
  END;
  ok:=ok & (pos.long<>0.0) & (pos.lat<>0.0) 
         & (ABS(pos.long)<180.0*RAD) & (ABS(pos.lat)<90.0*RAD);
  IF NOT ok THEN pos.long:=0.0; pos.lat:=0.0 END;

(*
IF ok THEN 
IO.WrStr(" lat/long:"); IO.WrFixed(pos.lat/RAD, 4,10); IO.WrFixed(pos.long/RAD, 4,10);
IO.WrStr(" min:"); IO.WrCard(TRUNC(ABS(pos.lat/RAD)),1); IO.WrStr(","); 
IO.WrFixed(60.0*ABS(pos.lat/RAD)-FLOAT(60*TRUNC(ABS(pos.lat/RAD))),2,5);
IO.WrStr(" min:"); IO.WrCard(TRUNC(ABS(pos.long/RAD)),1); IO.WrStr(",");
IO.WrFixed(60.0*ABS(pos.long/RAD)-FLOAT(60*TRUNC(ABS(pos.long/RAD))),2,5);
IO.WrFixed(distance(home,pos), 1, 10); IO.WrStr("km"); IO.WrLn;
ELSE IO.WrStrLn("============NO POS");
END;
*)

END GetPos;
*)

PROCEDURE FiltToStr(f:FILTERS; VAR s:ARRAY OF CHAR);

  PROCEDURE app(x:REAL; rad:BOOLEAN);
  VAR h:ARRAY[0..29] OF CHAR;
  BEGIN
    Append(s,"/");
    IF rad THEN FixToStr(x/RAD,5,h) ELSE FixToStr(x,0,h) END;
    Append(s,h);
  END app;

BEGIN
  s[0]:=0C;
  WITH f DO
    IF typ="a" THEN  
      Assign(s, "a");
      app(base.lat, TRUE);
      app(base.long, TRUE);
      app(edge.lat, TRUE);
      app(edge.long, TRUE);
    ELSIF typ="r" THEN
      Assign(s, "r");
      app(base.lat, TRUE);
      app(base.long, TRUE);
      app(radius, FALSE);
    ELSIF typ="m" THEN
      Assign(s, "m");
      app(radius, FALSE);
    END;
  END;
END FiltToStr;


PROCEDURE Watchclock(VAR t:TIME; intervall:TIME):BOOLEAN;
VAR tn:TIME;
BEGIN
  IF (intervall>0) OR (t=0) THEN    (* send once *)
    tn:=systime;
    IF t<=tn THEN
      INC(t, intervall);
      IF t<=tn THEN t:=tn+intervall END;
      RETURN TRUE
    END;
  END;
  RETURN FALSE
END Watchclock; 


PROCEDURE call2pass(c-:ARRAY OF CHAR):CARDINAL;
CONST ROOT=CAST(BITSET, 073E2H);
VAR i:CARDINAL;
    s:BITSET;
BEGIN
  s:=ROOT;
  i:=0;
  WHILE (i<=HIGH(c)) & (c[i]<>0C) & (c[i]<>"-") DO 
    s:=s/SHIFT(CAST(BITSET, ORD(CAP (c[i]))),VAL(INTEGER,NOT ODD(i))*8); 
    INC(i);
  END;
  RETURN CAST(CARDINAL, s*BITSET{0..14})
END call2pass;


PROCEDURE Gencrctab;
CONST POLINOM=08408H;
VAR i,crc,c:CARDINAL;
BEGIN
  FOR c:=0 TO 255 DO
    crc:=255-c;
    FOR i:=0 TO 7 DO
      IF ODD(crc) THEN crc:=CAST(CARDINAL, CAST(BITSET, ASH(crc, -1))/CAST(BITSET,POLINOM))
      ELSE crc:=ASH(crc, -1) END;
    END;
    CRCL[c]:=CAST(SET8, crc);
    CRCH[c]:=CAST(SET8, 255 - ASH(crc, -8));
  END;
END Gencrctab;




PROCEDURE AppCRC(VAR frame:ARRAY OF CHAR; size:INTEGER);
VAR l,h:SET8;
    b:CARD8;
    i:INTEGER;
BEGIN
  l:=SET8{};
  h:=SET8{};
  FOR i:=0 TO size-1 DO
    b:=CAST(CARD8, CAST(SET8, frame[i]) / l);
    l:=CRCL[b] / h;
    h:=CRCH[b];
  END;
  frame[size  ]:=CAST(CHAR, l);
  frame[size+1]:=CAST(CHAR, h);
END AppCRC;


PROCEDURE Call2Str(VAR r, t:ARRAY OF CHAR; pos:CARDINAL; VAR len:CARDINAL):BOOLEAN;
VAR i,e,ssid:CARDINAL;
    c:CHAR;
BEGIN
  e:=pos;
  FOR i:=pos TO pos+5 DO 
    IF r[i]<>100C THEN e:=i END;
  END; 
  FOR i:=pos TO e DO 
    c:=CHR(ASH(ORD(r[i]), -1));
    IF c<=" " THEN len:=0; RETURN FALSE END;
    t[len]:=c;
    INC(len);
  END;
  ssid:=ASH(ORD(r[pos+6]), -1) MOD 16;
  IF ssid>0 THEN 
    t[len]:="-"; INC(len); 
    IF ssid>9 THEN t[len]:="1"; INC(len); END;
    t[len]:=CHR(ssid MOD 10 + ORD("0")); INC(len);
  END;
  RETURN TRUE
END Call2Str;


PROCEDURE raw2mon(VAR raw, mon:ARRAY OF CHAR; len:CARDINAL);
VAR i,p:CARDINAL;
    hcheck:BOOLEAN;
BEGIN
  p:=0;
  mon[0]:=0C;
  i:=0;
  WHILE NOT ODD(ORD(raw[i])) DO 
    INC(i);
    IF i>len THEN mon[0]:=0C; RETURN END;                         (* no address end mark found *)
  END;
  IF i MOD 7 <> 6 THEN mon[0]:=0C; RETURN END;                    (* address end not modulo 7 error *)

  IF NOT Call2Str(raw,mon,7,p) THEN mon[0]:=0C; RETURN END; 
  mon[p]:=">"; INC(p);
  IF NOT Call2Str(raw,mon,0,p) THEN mon[0]:=0C; RETURN END;

  i:=14;
  hcheck:=TRUE;
  WHILE (i+6<len) & NOT ODD(ORD(raw[i-1])) DO
    mon[p]:=","; INC(p);
    IF NOT Call2Str(raw,mon,i,p) THEN mon[0]:=0C; RETURN END;
    IF ORD(raw[i+6])>=128 THEN
      IF NOT hcheck THEN mon[0]:=0C; RETURN END;                  (* wrong H bit *)
      IF (ODD(ORD(raw[i+6])) OR (ORD(raw[i+13])<128)) THEN mon[p]:="*"; INC(p); END;
    ELSE hcheck:=FALSE END;
    INC(i,7);
  END;  
  INC(i,2);  (* ctrl, pid *)

  mon[p]:=":"; INC(p);

  WHILE (i<len) & (p<HIGH(mon)-1) DO 
    IF (*raw[i]>=" "*) raw[i]<>0C THEN mon[p]:=raw[i]; INC(p); END; 
    INC(i);
  END;
(*
  mon[p]:=15C; INC(p);
  mon[p]:=12C; INC(p);
*)
  mon[p]:=0C; INC(p);

  mon[p]:=0C;

END raw2mon;




PROCEDURE GetIp(h:ARRAY OF CHAR; VAR ip:IPNUM; VAR port:UDPPORT):INTEGER;
VAR i, p, n:CARDINAL;
    ok:BOOLEAN;
BEGIN
  p:=0;
  h[HIGH(h)]:=0C;
  ip:=0;
  FOR i:=0 TO 4 DO
    n:=0;
    ok:=FALSE;
    WHILE (h[p]>="0") & (h[p]<="9") DO
      ok:=TRUE;
      n:=n*10+ORD(h[p])-ORD("0");
      INC(p);
    END;
    IF NOT ok THEN RETURN -1 END;
    IF i<3 THEN
      IF (h[p]<>".") OR (n>255) THEN RETURN -1 END;

      ip:=ip*256+n;
    ELSIF i=3 THEN
      ip:=ip*256+n;
      IF (h[p]<>":") OR (n>255) THEN RETURN -1 END;

    ELSIF n>65535 THEN RETURN -1 END;

    port:=n;
    INC(p);
  END;  
  RETURN 0
END GetIp;


PROCEDURE GetSec(h:ARRAY OF CHAR; VAR p, n:CARDINAL):INTEGER;
VAR ok:BOOLEAN;
BEGIN
  h[HIGH(h)]:=0C;
  n:=0;
  ok:=FALSE;
  WHILE (h[p]>="0") & (h[p]<="9") DO
    ok:=TRUE;
    n:=n*10+ORD(h[p])-ORD("0");
    INC(p);
  END;
  IF NOT ok THEN RETURN -1 END;
(*
IO.WrCard(n,10); IO.WrLn;
*)
  RETURN 0
END GetSec;

PROCEDURE callok(h-:ARRAY OF CHAR):BOOLEAN;
VAR i,num,lit:CARDINAL;
    c:CHAR;
BEGIN
  num:=0;
  lit:=0;
  i:=0;
  LOOP
    c:=h[i];
    IF (c>="0") & (c<="9") THEN INC(num) ELSIF (c>="A") & (c<="Z") THEN INC(lit) ELSE EXIT END;
    INC(i);
  END;
  IF (lit<2) OR (num=0) OR (num>2) THEN RETURN FALSE END;
  IF h[i]="-" THEN
    INC(i);
    IF h[i]="1" THEN
      INC(i);
      IF (h[i]>="0") & (h[i]<="5") THEN INC(i) END;
    ELSIF (h[i]<"1") OR (h[i]>"9") THEN RETURN FALSE ELSE INC(i) END;
  END;
  RETURN h[i]=0C
END callok;


PROCEDURE parms;
VAR h          : ARRAY[0..4095] OF CHAR;
    err        : BOOLEAN;
    lasth      : CHAR;
    i, n       : CARDINAL;
    gatecnt    : CARDINAL;
    fd, len    : INTEGER;
BEGIN
  err:=FALSE;
  show:=FALSE;
  keepconn:=FALSE;
  gatecnt:=0;
  LOOP
    NextArg(h);
    IF h[0]=0C THEN EXIT END;
    IF (h[0]="-") & (h[1]<>0C) & (h[2]=0C) THEN
      lasth:=h[1];

      IF (lasth="R") OR (lasth="M") THEN
        NextArg(h);
        WITH udpsock DO
          IF GetIp(h, fromip, bindport)<0 THEN Err("cannot open udp socket") END;
          fd:=udp.openudp();
          rawread:=lasth="R";
          IF (fd>=0) & (udp.bindudp(fd, bindport)<0) THEN Err("cannot bind udpport") END;
        END;

      ELSIF (lasth="s") OR (lasth="S") THEN
        NextArg(h);
        Assign(servercall, h);
        IF (servercall[0]=0C) OR (servercall[0]="-") OR ((lasth="s") & NOT callok(h)) 
        THEN Err("-s call-ssid") END;

      ELSIF lasth="p" THEN
        NextArg(h);
        IF (h[0]>="0") & (h[0]<="9") THEN
          i:=0;  
          WHILE (i<=HIGH(passwd)) & (h[i]>=" ") DO passwd[i]:=h[i]; INC(i) END;
        ELSE
          fd:=OpenMode(h, oRDONLY);
          IF fd<0 THEN Err("-p passcode or passwordfile") END;
          len:=RdBin(fd, passwd, SIZE(passwd)-1);
          IF len>=0 THEN passwd[len]:=0C ELSE Err("error with password file") END;
          Close(fd);
        END;
        passwd[HIGH(passwd)]:=0C;
        i:=0; 
        WHILE (passwd[i]>="0") & (passwd[i]<="9") DO INC(i) END;
        IF (i=0) OR (passwd[i]<>0C) THEN Err("invalid passcode") END;

      ELSIF lasth="m" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN maxusers:=n ELSE Err("-m number") END;

      ELSIF lasth="d" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN dupetime:=n ELSE Err("-d number") END;
        IF dupetime<27 THEN IO.WrStrLn("do not set dupefilter less 27s!") END;

      ELSIF lasth="l" THEN
        NextArg(h);
        i:=0;
        IF (GetSec(h,i,n)>=0) & (h[i]=":") THEN
          logframes:=n;
          INC(i);
          FOR n:=0 TO HIGH(logframename) DO 
            IF i<=HIGH(h) THEN 
              logframename[n]:=h[i];
              INC(i);
            END;
          END;
          IF logframename[0]<=" " THEN Err("log filename") END;
        ELSE Err("log format is level:file") END;

      ELSIF lasth="n" THEN
        NextArg(h);
        i:=0;
        IF (GetSec(h,i,n)>=0) & (h[i]=":") THEN
          netbeaconintervall:=n*60;
          INC(i);
          FOR n:=0 TO HIGH(netbeaconfn) DO 
            IF i<=HIGH(h) THEN 
              netbeaconfn[n]:=h[i];
              INC(i);
            END;
          END;
          IF netbeaconfn[0]<=" " THEN Err("netbeacon filename") END;
        ELSE Err("netbeacon format is minutes:file") END;

      ELSIF lasth="t" THEN
        NextArg(h);
        Assign(tcpbindport, h);
        IF (h[0]=0C) OR (h[0]="-") THEN Err("-t port") END;

      ELSIF lasth="w" THEN
        NextArg(h);
        Assign(wwwbindport, h);
        IF (h[0]=0C) OR (h[0]="-") THEN Err("-w port") END;

      ELSIF lasth="f" THEN
        NextArg(h);
        Assign(serverrangefilter, h);
        IF (h[0]=0C) OR (h[0]="-") THEN Err("-f rangefilter") END;


      ELSIF lasth="g" THEN
        NextArg(h);
        IF gatecnt>HIGH(gateways) THEN Err("gateway table full") END;
        Assign(gateways[gatecnt].url, h);
        IF h[0]=0C THEN Err("-g url port") END;
        NextArg(h);
        Assign(gateways[gatecnt].port, h);
        IF h[0]=0C THEN Err("-g url port") END;
        INC(gatecnt);

      ELSIF lasth="h" THEN
        IO.WrStrLn(" -d <s>         dupe filter time in seconds, not below 27s! (default 60s)");
        IO.WrStrLn(" -f <filters>   range filter sent to out connected server -f m/50");
        IO.WrStrLn(" -g <url> <port> connect to aprs-is gateway(s), repeat -g for round robin");   
        IO.WrStrLn("                -g www.db0anf.de 14580 -g 127.0.0.1 3000 -g ::1 3000");
        IO.WrStrLn("                ipv6 if enabled by kernel");
        IO.WrStrLn(" -h             this");
        IO.WrStrLn(" -k             make gateway connect even if no data is to send to");
        IO.WrStrLn(" -l <level>:<file> logfile -l 6:/tmp/log.txt");
        IO.WrStrLn("                level: 1 logins, 2 +sent frames, 6 +fitered frames, 7 +dups");
        IO.WrStrLn(" -M <ip>:<port> read monitor udp frame, 0 ip read from all (-M 0.0.0.0:2000)");
        IO.WrStrLn(" -m <maxconnects> max inbound connects -m 5 (default 20)");
        IO.WrStrLn(" -n <min>:<file> netbeacon minutes:filename -n 10:netbeacon.txt");
        IO.WrStrLn("                beacon file like: !8959.00N/17959.00E&igate mars");
        IO.WrStrLn(" -p <password>  login passwort for aprs-is servers -p 12345");
        IO.WrStrLn("                to hide password in commandline use file mode -p pass.txt");
        IO.WrStrLn(" -R <ip>:<port> read raw axudp frame, 0 ip read from all (-R 0.0.0.0:2000)");
        IO.WrStrLn(" -s <call>      server call of this server -s MYCALL-10 (-S no callcheck)");
        IO.WrStrLn(" -t <localport> local igate tcp port for in connects -t 14580");
        IO.WrStrLn(" -v             show frames and analytics on stdout");
        IO.WrStrLn(" -w <port>      port of www server -t 14501");
        IO.WrStrLn("udpgate -v -R 0.0.0.0:9200 -c MYCALL-10 -l 7:aprs.log -n 10:beacon.txt -t 14580 -g www.server.org 14580 -p 12345");

        HALT

      ELSIF lasth="v" THEN
        show:=TRUE;

      ELSIF lasth="k" THEN
        keepconn:=TRUE;

      ELSE err:=TRUE END;
      (*h[0]:=0C;*)
    ELSE err:=TRUE END;
    IF err THEN EXIT END;
  END;
  IF err THEN IO.WrStr(">"); IO.WrStr(h); IO.WrStrLn("< use -h"); HALT END;
  IF servercall[0]=0C THEN IO.WrLn; IO.WrStrLn("NO SERVERCALL ?"); IO.WrLn; END;
END parms;




PROCEDURE getudp(fd:INTEGER; VAR buf:FRAMEBUF; fromip:IPNUM; raw:BOOLEAN);
VAR fromport     : UDPPORT;
    ip           : IPNUM;
    crc1, crc2   : CHAR;
    len, i, oldi : INTEGER;
    mbuf         : FRAMEBUF; 
    oldt         : TIME;
    
BEGIN
  len:=udp.udpreceive(fd, buf, SIZE(buf), fromport, ip);
  IF (len>2) & (len<CAST(INTEGER, SIZE(buf))) & ((fromip=0) OR (fromip=ip)) THEN
    buf[len]:=0C;
    IF raw THEN
      crc1:=buf[len-2];
      crc2:=buf[len-1];
      AppCRC(buf, len-2);
      IF (crc1<>buf[len-2]) OR (crc2<>buf[len-1]) THEN 
        IF show THEN IO.WrStrLn(" axudp crc error") END; 
      ELSE  
        raw2mon(buf, mbuf, len-2);
        IF (mbuf[0]=0C) & show THEN 
          IO.WrStrLn(" axudp frame decode error");

 FOR i:=0 TO len-3 DO IO.WrHex(ORD(buf[i]),3) END;
 IO.WrLn;
 i:=0;
 LOOP
   IF i>=len-3 THEN EXIT END;
   IF ORD(buf[i]) DIV 2<ORD(" ") THEN IO.WrChar("<") ;IO.WrHex(ORD(buf[i]) DIV 2,1); IO.WrChar(">"); ELSE IO.WrChar(CHR(ORD(buf[i]) DIV 2)) END;
   IF ODD(ORD(buf[i])) THEN EXIT END;
   IF i MOD 7=6 THEN IO.WrStr(",") END;
   INC(i);
 END;
 IO.WrLn;

        END;
        buf:=mbuf;
      END; 
      len:=Length(buf);                  (* for statistic *)
    ELSE buf[len]:=0C END;

(* statistic *)
    i:=0;
    oldt:=systime;
    oldi:=0;
    LOOP
      IF (udpsock.stat[i].uip=ip) & (udpsock.stat[i].uport=fromport) THEN
        oldi:=i;
        i:=HIGH(udpsock.stat);
      END;
      IF i>=HIGH(udpsock.stat) THEN
        WITH udpsock.stat[oldi] DO
          uport:=fromport;
          uip:=ip;
          IF (utime>systime) OR (utime+UDPSHOWTIME<systime) THEN (* reset statistic *)
            dtime:=systime;
            txframes:=0;
            txbytes:=0;
            rxframes:=0;
            rxbytes:=0;
          END;
          INC(rxframes);
          INC(rxbytes, len);
          utime:=systime;
          udpsock.laststat:=oldi;
        END;
        EXIT
      END;

      IF udpsock.stat[i].utime<oldt THEN
        oldt:=udpsock.stat[i].utime;
        oldi:=i;
      END;

      INC(i);
    END;
  END;
END getudp; 
    

PROCEDURE Gettcp(fd:INTEGER; VAR line, buf:FRAMEBUF; VAR pos:INTEGER):INTEGER;
VAR len,i,j:INTEGER;
    h:FRAMEBUF;
BEGIN
  i:=pos;
  IF i>=SIZE(line) THEN i:=0 END;                             (* pos>SIZE is overflow mode *)
(*
  len:=RdBin(fd, line, SIZE(line)-i);
  IF len<=0 THEN RETURN -1 END;                               (* disconnected *)
*)
(*
  IF len<0 THEN len:=0 END;
*)
  len:=tcp.readsock(fd, line, SIZE(line)-i);

  IF len<0 THEN RETURN -1 END;

  IF pos>=SIZE(buf) THEN                                      (* hunt mode *)
    i:=0; 
    WHILE (i<len) & (line[i]<>12C) DO INC(i) END;
    IF i>=len THEN RETURN 0 END;                              (* no line start found *)
    pos:=0;
    INC(i);
    j:=0;
    WHILE i<len DO line[j]:=line[i]; INC(j); INC(i) END;
    len:=j;
  END;

  IF pos>0 THEN
    FOR i:=len-1 TO 0 BY -1 DO line[i+pos]:=line[i] END;      (* move up new *)
    FOR i:=0 TO pos-1 DO line[i]:=buf[i] END;                 (* ins buf before *)
    INC(len,pos);
    pos:=0;  
  END;

  i:=0;
  WHILE (i<len) & (line[i]<>12C) DO INC(i) END;
  IF i>=len THEN                                              (* no line end found *)
    WHILE pos<len DO buf[pos]:=line[pos]; INC(pos) END;       (* move to buf *)
    len:=0;  
  ELSE
    j:=i+1;
    WHILE j<len DO buf[pos]:=line[j]; INC(pos); INC(j) END;   (* move rest to buf *)  
    len:=i;
  END;
  line[len]:=0C;
  RETURN len
END Gettcp;

PROCEDURE showpip(ip:IPNUM; port:UDPPORT; VAR s:ARRAY OF CHAR);
VAR h:ARRAY[0..20] OF CHAR;
BEGIN
  IntToStr(ip DIV 1000000H, 1, s);
  Append(s,".");
  IntToStr(ip DIV 10000H MOD 100H, 1, h);
  Append(s,h);
  Append(s,".");
  IntToStr(ip DIV 100H MOD 100H, 1, h);
  Append(s,h);
  Append(s,".");
  IntToStr(ip MOD 100H, 1, h);
  Append(s,h);
  IF port<>0 THEN
    Append(s,":");
    IntToStr(port, 1, h);
    Append(s,h);
  END;
END showpip;

PROCEDURE clrstr(VAR s:ARRAY OF CHAR);
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE (i<=HIGH(s)) & (s[i]<>0C) DO
    IF s[i]<" " THEN s[i]:="." END;
    INC(i);
  END;
END clrstr;


PROCEDURE logline(r:INTEGER; s:ARRAY OF CHAR);
VAR h:ARRAY[0..511] OF CHAR;
    fd:INTEGER;
    i:CARDINAL;
BEGIN
  IF (logframename[0]<>0C) & (logframes+r>1) THEN
    fd:=OpenMode(logframename, oWRONLY+oAPPEND);
    IF fd<0 THEN fd:=Create(logframename) END;
    IF fd>=0 THEN
      DateToStr(systime, h);
      Append(h, " ");
      Append(h, s);
      Append(h,""+LF);
      WrBin(fd, h, Length(h));
      Close(fd);
    ELSE IO.WrStr("cannot write"); IO.WrStr(logframename); IO.WrLn; END;
  END;
  IF show (* & (r<>-5) *) THEN 
    i:=Length(s);
    IF (i>=2) & (s[i-1]=LF) & (s[i-2]=CR) THEN s[i-2]:=0C END; 
    CtrlHex(s);
    IO.WrStrLn(s);
  END;
END logline;



PROCEDURE showframe(r:INTEGER; sp:pTCPSOCK; buf-:ARRAY OF CHAR; pos:POSITION);
VAR h, s:ARRAY[0..511] OF CHAR;
BEGIN
  IF sp=NIL THEN 
    s:="U:";
    WITH udpsock DO 
      IF (stat[laststat].uip<>showip1) OR (stat[laststat].uport<>showport1) THEN
        showip1:=stat[laststat].uip;
        showport1:=stat[laststat].uport;
        showpip(showip1, showport1, h); Append(s,h); Append(s,":");
      END;
    END;
  ELSE
    s[0]:=sp^.service; s[1]:=":"; s[2]:=0C; 
    IF (sp^.user.call[0]<>0C) & NOT StrCmp(sp^.user.call, showid) THEN
      Append(s, sp^.user.call); Append(s,":");
      Assign(showid, sp^.user.call);
    END;
  END;
(*
IO.WrFixed(distance(home,pos), 1, 10); IO.WrStr("km"); IO.WrLn;
*)
  CASE r OF
   | 0: IF NOT posvalid(pos) OR NOT posvalid(home) THEN h:="--->" 
        ELSE IntToStr(TRUNC(0.5+distance(home, pos)), 3, h); Append(h, ">") END;
   |-1: h:="syn:";
   |-2: h:="len:";
   |-3: h:="cal:";
   |-4: h:="msg:";
   |-5: h:="dup:";
  ELSE  h:="   :";
  END;
  Append(s,h);
  Append(s, buf);
  logline(r, s);
END showframe;

PROCEDURE Statist(cp:pTCPSOCK; t:TIME; VAR s:ARRAY OF CHAR);
VAR h:ARRAY[0..255] OF CHAR;
BEGIN
  WITH cp^ DO
    IF connt<t THEN DEC(t, connt) ELSE t:=0 END;
    Assign(s, " t="); TimeToStr(t, h); Append(s, h);
    IntToStr(txframes, 1, h); Append(s, " txf=");Append(s, h);
    IntToStr(rxframes, 1, h); Append(s, " rxf=");Append(s, h);
    IntToStr(txbytes,  1, h); Append(s, " txB=");Append(s, h);
    IntToStr(rxbytes,  1, h); Append(s, " rxB=");Append(s, h);
    IF t>0 THEN
      Append(s, " ");
      IntToStr(txbytes*8 DIV t,  1, h); Append(s, h); Append(s, "tbit/s "); 
      IntToStr(rxbytes*8 DIV t,  1, h); Append(s, h); Append(s, "rbit/s");
    END;
  END;
END Statist;



PROCEDURE showlogout(sp:pTCPSOCK);
VAR h,t:ARRAY[0..255] OF CHAR;
    ti:CARDINAL;
BEGIN
  WITH sp^ DO
    h:="T:connection closed "; Append(h, user.call); Append(h," "); Append(h, ipnum); 
    IF connt<>0 THEN
      Statist(sp, systime, t);
(*
      ti:=time();
      IF ti<connt THEN ti:=0 ELSE DEC(ti, connt) END;
      Append(h," conntime ");
      TimeToStr(ti, t); 
*)
      Append(h, t); 
    END;
    Append(h,""+LF);
  END;
  logline(1, h);
END showlogout;



PROCEDURE Filter(to:pTCPSOCK; posc:POSCALL):BOOLEAN;
BEGIN
  IF posc.typ=cUSERMESSAGE THEN RETURN TRUE END;                     (* pass messages and ack *)
  IF to^.filters.typ="m" THEN
    RETURN posvalid(to^.user.pos) & posvalid(posc.pos) 
         & (distance(to^.user.pos, posc.pos)<=to^.filters.radius)
  ELSIF to^.filters.typ="r" THEN
(*
IO.WrStr("    blbl:"); IO.WrFixed(to^.filters.base.lat/RAD, 4,10);IO.WrFixed(to^.filters.base.long/RAD, 4,10);
IO.WrFixed(pos.lat/RAD, 4,10); IO.WrFixed(pos.long/RAD, 4,10); 
IO.WrFixed(distance(to^.filters.base, pos), 4,10); IO.WrFixed(to^.filters.radius, 4,10);
IO.WrLn;
*)
    RETURN posvalid(posc.pos) & (distance(to^.filters.base, posc.pos)<=to^.filters.radius)
  ELSIF to^.filters.typ="a" THEN
    RETURN posvalid(posc.pos) & (to^.filters.base.lat>=posc.pos.lat) 
         & (to^.filters.base.long>=posc.pos.long)
         & (to^.filters.edge.lat<=posc.pos.lat) & (to^.filters.edge.long<=posc.pos.long) 
  END;
  RETURN TRUE;
END Filter;


PROCEDURE Sendtcp(to:pTCPSOCK; VAR buf:FRAMEBUF);
VAR len,i:INTEGER;
BEGIN
  len:=Length(buf);
  WITH to^ DO
    IF tlen+len<SIZE(tbuf) THEN
      FOR i:=0 TO len-1 DO tbuf[tlen]:=buf[i]; INC(tlen) END; 
      INC(txframes);
      INC(txbytes, len);
    ELSIF show THEN IO.WrStrLn("tx buf overflow") END;
  END;
END Sendtcp;


PROCEDURE Sendall(VAR buf:FRAMEBUF; fromfd:INTEGER; posc:POSCALL);
VAR t:pTCPSOCK; 
BEGIN
  IF buf[0]<>0C THEN
    t:=tcpsocks;
    WHILE t<>NIL DO
      IF (t^.fd<>fromfd) & (t^.service<>cISWWW) & Filter(t, posc) THEN Sendtcp(t, buf) END;
      t:=t^.next;
    END;
  END;
END Sendall;



PROCEDURE cmpfrom(a-:ARRAY OF CHAR; from:CARDINAL; b-:ARRAY OF CHAR):BOOLEAN;
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE (from<=HIGH(a)) & (b[i]<>0C) DO
    IF a[from]<>b[i] THEN RETURN FALSE END;
    INC(i); 
    INC(from);
  END;
  RETURN TRUE
END cmpfrom;


PROCEDURE Netbeacon(VAR h:ARRAY OF CHAR);
VAR f,i:INTEGER;
    h1:FRAMEBUF;
BEGIN
  h[0]:=0C;
  IF netbeaconfn[0]<>0C THEN
    f:=OpenMode(netbeaconfn, oRDONLY);  
    IF f>=0 THEN
      i:=RdBin(f, h1, SIZE(h1)-1);
      IF i>=0 THEN
        h1[i]:=0C;
        i:=0;
        WHILE h1[i]>=" " DO INC(i) END;
        h1[i]:=0C;
        Assign(h, servercall);
        Append(h, ">APNL51,TCPIP*,qAI,");
        Append(h, servercall);
        Append(h, ":");
        Append(h, h1);
        Append(h, CR+LF);
      END;
      Close(f);
    ELSIF show THEN IO.WrStrLn("netbeacon file not found") END;
  END;
END Netbeacon;


PROCEDURE Timebeacon(cp:pTCPSOCK);
VAR h:FRAMEBUF;
BEGIN
  IF Watchclock(cp^.beacont, netbeaconintervall) THEN
    IF cp^.service<>cISWWW THEN
      Netbeacon(h);
      IF h[0]<>0C THEN Sendtcp(cp, h) END;
    END;
  END;
END Timebeacon;


PROCEDURE AprsIs(VAR buf:ARRAY OF CHAR; apptext-:ARRAY OF CHAR; tablen:CARDINAL; VAR poscall:POSCALL):INTEGER;
VAR i,p,len,pins,pssid,psum0,psum1,ilen,ha,payload,micedest:CARDINAL;
    hashl, hashh:SET8;

  PROCEDURE hash(c:CHAR);
  VAR b:CARD8;
  BEGIN
    IF c<>" " THEN
      b:=CAST(CARD8, CAST(SET8, c) / hashl);
      hashl:=CRCL[b] / hashh;
      hashh:=CRCH[b];
    END;
  END hash;


  PROCEDURE callchk(withstar, iscall:BOOLEAN):BOOLEAN;
  VAR i,j,u,num,lit:CARDINAL;
      c:CHAR;
  BEGIN
    u:=0;
    WHILE u<tablen DO
      j:=0;
      i:=p;
      WHILE ungate[u][j]=buf[i] DO
        INC(i);
        INC(j);
        IF ungate[u][j]=0C THEN RETURN FALSE END;
      END;
      INC(u);
    END;

    IF NOT iscall & (buf[p]="q") & (buf[p+1]="A") & (buf[p+2]>="A") THEN INC(p, 3)   (* qA* *)
    ELSE
      num:=0;
      lit:=0;
      LOOP
        c:=buf[p];
        IF (c>="0") & (c<="9") THEN INC(num) ELSIF (c>="A") & (c<="Z") THEN INC(lit) ELSE EXIT END; 
        INC(p);
      END;
      IF iscall & ((lit<2) OR (num=0) OR (num>2)) THEN RETURN FALSE END;
    END;
(*
  WHILE ORD(buf[p]) IN LIT DO INC(p) END;
*)
    pssid:=p;
    IF buf[p]="-" THEN
      INC(p);
      IF buf[p]="1" THEN 
        INC(p);
        IF (buf[p]>="0") & (buf[p]<="5") THEN INC(p) END;
      ELSIF (buf[p]<"1") OR (buf[p]>"9") THEN RETURN FALSE ELSE INC(p) END;
    END;
    IF withstar & (buf[p]="*") THEN INC(p) END;

    RETURN TRUE
  END callchk;

BEGIN
  hashl:=SET8{};
  hashh:=SET8{};
  p:=0;
  pins:=0;
  ilen:=Length(apptext);
  len:=Length(buf);
  IF (len=0) OR (len+ilen+3>HIGH(buf)) THEN RETURN -2 END;
  IF buf[0]="#" THEN RETURN -6 END;
  LOOP
    psum0:=p;
    IF NOT callchk(FALSE, TRUE) THEN RETURN -3 END; 
    IF buf[p]<>">" THEN RETURN -1 END;

    i:=0; 
    WHILE (i<HIGH(poscall.call)) & (i<p) DO poscall.call[i]:=buf[i]; INC(i) END;
    poscall.call[i]:=0C;    

    INC(p);
    micedest:=p;  
    IF NOT callchk(FALSE, FALSE) THEN RETURN -3 END;
    psum1:=pssid;
    WHILE buf[p]="," DO
      INC(p);
      IF NOT callchk(TRUE, FALSE) THEN RETURN -3 END;
    END;
    IF buf[p]<>":" THEN RETURN -1 END;
    IF pins=0 THEN pins:=p END;
    INC(p);
    IF buf[p]<>"}" THEN EXIT END;
    INC(p);
  END;
  payload:=p;
  poscall.typ:=buf[p];
  IF buf[p]="?" THEN RETURN -4 END;
  FOR i:=psum0 TO psum1-1 DO hash(buf[i]) END;
  WHILE (p<len) & (buf[p]<>15C) & (buf[p]<>12C) DO hash(buf[p]); INC(p) END;

  ha:=(ORD(CAST(CHAR, hashl)) + ORD(CAST(CHAR, hashh))*256) MOD HASHSIZE;
  IF timehash[ha]+dupetime>systime THEN RETURN -5 END;                       (* a duplicate *)
  timehash[ha]:=systime;

  GetPos(poscall.pos, buf, micedest, payload); 

  buf[p]:=15C; INC(p);
  buf[p]:=12C; INC(p);
  buf[p]:=0C;  INC(p);

  IF ilen>0 THEN
    WHILE p>pins DO DEC(p); buf[p+ilen]:=buf[p] END;
    i:=0;

    WHILE i<ilen DO buf[p]:=apptext[i]; INC(p); INC(i) END;
  END;
  RETURN 0
END AprsIs;

PROCEDURE GetFilters(VAR filters:FILTERS; s-:ARRAY OF CHAR; p:CARDINAL);

  PROCEDURE getfix(VAR x:REAL; mul:REAL):BOOLEAN;
  VAR i:CARDINAL;
      h:FRAMEBUF;
  BEGIN
    IF s[p]="/" THEN 
      INC(p);
      i:=0;
      WHILE (s[p]>" ") & (s[p]<>"/") & (i<HIGH(h)) DO h[i]:=s[p]; INC(i); INC(p) END;
      h[i]:=0C;
      IF StrToFix(x, h) THEN
(*
IO.WrFixed(x, 4,10); IO.WrStr("   fix<"); IO.WrStr(h); IO.WrStrLn(">");
*)
        x:=x*mul;
        RETURN TRUE
      END;
    END;
    RETURN FALSE
  END getfix;

BEGIN
  WHILE s[p]=" " DO INC(p) END;
  WHILE s[p]>=" " DO
    WHILE s[p]=" " DO INC(p) END;
    IF s[p]="m" THEN
      INC(p);
      IF getfix(filters.radius, 1.0) THEN filters.typ:="m" ELSE RETURN END;
    ELSIF s[p]="r" THEN
      INC(p);
      IF NOT getfix(filters.base.lat, RAD) THEN RETURN END;
      IF NOT getfix(filters.base.long, RAD) THEN RETURN END;
      IF NOT getfix(filters.radius, 1.0) THEN RETURN END;
      IF NOT posvalid(filters.base) THEN RETURN END;
      filters.typ:="r";
    ELSIF s[p]="a" THEN
      INC(p);
      IF NOT getfix(filters.base.lat, RAD) THEN RETURN END;
      IF NOT getfix(filters.base.long, RAD) THEN RETURN END;
      IF NOT getfix(filters.edge.lat, RAD) THEN RETURN END;
      IF NOT getfix(filters.edge.long, RAD) THEN RETURN END;
      IF NOT posvalid(filters.base) THEN RETURN END;
      IF NOT posvalid(filters.edge) THEN RETURN END;
      filters.typ:="a";
    ELSE RETURN END;
  END;
END GetFilters;


PROCEDURE Auth(mbuf-:ARRAY OF CHAR; pu:pTCPSOCK):BOOLEAN;
VAR i,j:CARDINAL;
    h, h1:FRAMEBUF;
BEGIN
  WITH pu^ DO
    i:=0;
    WHILE mbuf[i]=" " DO INC(i) END;
    IF mbuf[i]="#" THEN RETURN TRUE END;
    IF mbuf[i]<>"u" THEN RETURN FALSE END;
    IF cmpfrom(mbuf,i,"user ") THEN
      INC(i,5);
      WHILE mbuf[i]=" " DO INC(i) END;
      j:=0;
      WHILE (j<HIGH(user.call)) & (mbuf[i]>" ") DO user.call[j]:=mbuf[i]; INC(i); INC(j); END;
      user.call[j]:=0C;

      WHILE mbuf[i]=" " DO INC(i) END;

      IF cmpfrom(mbuf,i,"pass ") THEN
        INC(i,5);
        WHILE mbuf[i]=" " DO INC(i) END;
        j:=0;
        WHILE (mbuf[i]>="0") & (mbuf[i]<="9") & (j<32768) DO 
          j:=j*10+ORD(mbuf[i])-ORD("0"); 
          INC(i); 
        END;
        valid:=j=call2pass(user.call);

        WHILE mbuf[i]=" " DO INC(i) END;
      END;

      IF cmpfrom(mbuf,i,"vers ") THEN
        INC(i,5);
        WHILE mbuf[i]=" " DO INC(i) END;
        j:=0;
        WHILE (mbuf[i]>=" ") & NOT cmpfrom(mbuf, i, "filter") DO
          IF j<HIGH(vers) THEN vers[j]:=mbuf[i]; INC(j) END; 
          INC(i);
        END;
        WHILE (j>0) & (vers[j-1]=" ") DO DEC(j) END;
        vers[j]:=0C;
      END;

      IF cmpfrom(mbuf, i, "filter ") THEN INC(i,7); GetFilters(filters, mbuf, i) END;

      Assign(h, "# logresp ");
      Append(h, user.call);
      IF valid THEN Append(h, " verified") END;
      Append(h, " server "); Append(h, servercall);
      FiltToStr(filters, h1); 
      IF h1[0]<>0C THEN Append(h, " filter "); Append(h, h1) END;
      Assign(h1,h);
      IF vers[0]<>0C THEN Append(h1, " vers: "); Append(h1, vers); END;
      logline(1, h1);

      Append(h, CR+LF);
      Sendtcp(pu, h);

    END;  
  END;
  RETURN TRUE
END Auth;

PROCEDURE Www(pwww:pTCPSOCK; get-:ARRAY OF CHAR);
VAR h    : ARRAY[0..1023] OF CHAR;
    h1   : ARRAY[0..255] OF CHAR;
    res  : INTEGER;
    tt, ut: TIME;
    ss   : pTCPSOCK;
    i    : CARDINAL;

  PROCEDURE wint(n:INTEGER);
  VAR h1:ARRAY[0..15] OF CHAR;
  BEGIN 
    IntToStr(n,  1, h1); Append(h, '<TD ALIGN="RIGHT">'); Append(h, h1); Append(h, "</TD>");
  END wint;

BEGIN
  i:=0;
  WHILE (i<=8) & NOT cmpfrom(get, i, " / ") DO INC(i) END;

  REPEAT UNTIL tcp.readsock(pwww^.fd, h, SIZE(h))<=0;                (* clear iput buffer *)

  IF i>=8 THEN h:="HTTP/1.0 404"+CR+LF;
  ELSE
    h:='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'+CR+LF
      +'<HTML><HEAD><TITLE>';
    IF servercall[0]<>0C THEN Append(h, servercall) END;
    Append(h, ' Status Report</TITLE>'+CR+LF+'<style type="text/css">'+CR+LF
             +'<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">'+CR+LF
             +'<meta name="robots" content="noindex,nofollow">'
             +'</style></HEAD><BODY><div align="center"><H3>'+CR+LF);
    IF servercall[0]<>0C THEN Append(h, "Server "); Append(h, servercall) END;
    Append(h, " ["); Append(h, VERS);
    Append(h, "] Maxusers "); IntToStr(maxusers, 1, h1); Append(h, h1);
    IF uptime<systime THEN TimeToStr(systime-uptime, h1); Append(h, " Uptime "); Append(h, h1) END;
    Append(h, "</H3></div>"+CR+LF);
    res:=tcp.sendmore(pwww^.fd, h, Length(h));

    h:='<TABLE BORDER="0" CELLPADDING="3" CELLSPACING="1" BGCOLOR="#000000" ALIGN="CENTER" SUMMARY="Connection Table">'+CR+LF
      +'<TR VALIGN="BASELINE" BGCOLOR="#9999CC">'
      +'<TH COLSPAN=14 ALIGN="CENTER">Server Connections</TH></TR>'+CR+LF
      +'<TR BGCOLOR="#CCCCFF">'+CR+LF+'<TH>Dir</TH><TH>IPnum</TH><TH>Port</TH><TH>Call</TH>'
      +'<TH>V</TH> <TH>Software</TH> <TH NOWRAP>Range Filter</TH>'
      +'<TH>TxByte</TH> <TH>TxFr</TH><TH NOWRAP>bit/s</TH>'
      +'<TH>RxByte</TH> <TH>RxFr</TH><TH NOWRAP>bit/s</TH><TH>Up</TH></TR>';

    res:=tcp.sendmore(pwww^.fd, h, Length(h));
    IF udpsock.fd>=0 THEN
      FOR i:=0 TO HIGH(udpsock.stat) DO
        WITH udpsock.stat[i] DO  
          IF utime+UDPSHOWTIME>systime THEN
            showpip(uip, 0, h1);
            h:='<TR BGCOLOR="#E0E0F0" ALIGN="CENTER">'+CR+LF+'<TD>udp</TD><TD>';
            Append(h, h1); Append(h, "</TD>");
            wint(uport); 
            Append(h, "<TD></TD><TD></TD><TD></TD><TD></TD>");
            wint(txbytes);
            wint(txframes);
            IF dtime<systime THEN ut:=systime-dtime ELSE ut:=1 END;
            wint(txbytes*8 DIV ut);
            wint(rxbytes);
            wint(rxframes);
            wint(rxbytes*8 DIV ut); Append(h, "<TD>");
            TimeToStr(ut, h1); Append(h, h1);
            Append(h, "</TD></TR>");  

            res:=tcp.sendmore(pwww^.fd, h, Length(h));
          END;
        END;
      END; 
    END;


    ss:=tcpsocks;
    WHILE ss<>NIL DO
      WITH ss^ DO
        IF (connt>0) & ((service=cISSERVER) OR (service=cISGATEWAY)) THEN
          IF connt<systime THEN tt:=systime-connt ELSE tt:=1 END;
          h:='<TR ALIGN="CENTER" ';
          IF service=cISSERVER THEN Append(h, 'BGCOLOR="#C0E0C0"><TD>in') 
          ELSE Append(h, 'BGCOLOR="#D0C0C0"><TD>out') END; 
          Append(h, '</TD><TD ALIGN="CENTER">');
          Append(h, ipnum); Append(h, '</TD><TD ALIGN="RIGHT">');
          Append(h, port); Append(h, '</TD><TD ALIGN="LEFT">');
          Append(h, user.call); Append(h, "</TD><TD>");
          IF valid THEN Append(h, "v") END; 
          IF posvalid(user.pos) THEN Append(h, "p") END;
          Append(h, "</TD><TD WIDTH=50>");
          Append(h, vers); Append(h, '</TD><TD WIDTH=50>');
          IF service=cISSERVER THEN FiltToStr(filters, h1) ELSE Assign(h1, serverrangefilter) END;
          Append(h, h1); Append(h, '</TD>');
          wint(txbytes);
          wint(txframes);
          wint(txbytes*8 DIV tt);
          wint(rxbytes);
          wint(rxframes);
          wint(rxbytes*8 DIV tt); Append(h, "<TD>");
          TimeToStr(tt, h1); Append(h, h1); Append(h, "</TD></TR>");
          res:=tcp.sendmore(pwww^.fd, h, Length(h));
        END;
        ss:=next;
      END;
    END;
    h:="</TABLE></BODY></HTML>";
  END;
  res:=tcp.sendsock(pwww^.fd, h, Length(h));
  Close(pwww^.fd);
  pwww^.fd:=-1;
END Www;


PROCEDURE tcpconn(VAR sockchain:pTCPSOCK; f:INTEGER; cservice:CHAR);
VAR cp:pTCPSOCK;
    h,h1,h2:FRAMEBUF;
    res:INTEGER;
BEGIN

  IF f>=0 THEN
    ALLOCATE(cp, SIZE(cp^));
    IF cp=NIL THEN
      Close(f);
      IF show THEN IO.WrStrLn("tcp conn out of memory") END;
    ELSE
      FILL(cp, 0C, SIZE(cp^));
      WITH cp^ DO
        fd:=f;
        valid:=cservice=cISGATEWAY;
        service:=cservice;
        res:=udp.socknonblock(f);
      END;
      cp^.next:=sockchain;
      sockchain:=cp;


      IF cservice=cISGATEWAY THEN

(*
res:=SIZE(sockadr); 
res:=tcp.getpeeripnum(f, sockadr, res);
IF res>=0 THEN
  tcp.ipnumport2str(sockadr, SIZE(sockadr), h, SIZE(h), h1, SIZE(h1));
  Assign(cp^.ipnum, h);
  Assign(cp^.port, h1);
  h:="T:connect to: "; Append(h, cp^.ipnum); Append(h, " "); Append(h, cp^.port);
  logline(1, h);
END;
  h:="T:connect to: "; Append(h, cp^.ipnum); Append(h, " "); Append(h, cp^.port);
  logline(1, h);
*)

        IF servercall[0]<>0C THEN
          Assign(h, "user ");
          Append(h, servercall);
          IF passwd[0]<>0C THEN Append(h, " pass "); Append(h, passwd) END;
          Append(h, " vers ");
          Append(h, VERS);
          IF serverrangefilter[0]<>0C THEN Append(h, " filter "); Append(h, serverrangefilter) END;
        END;
        Append(h, ""+CR+LF);
        Sendtcp(cp, h);
      ELSIF cservice=cISSERVER THEN

        res:=SIZE(h1);
        res:=tcp.getpeeripnum(f, h1, res);
        IF res>=0 THEN
(*
          tcp.ipnum2str(h1, h, SIZE(h));
*)
          tcp.ipnumport2str(h1, SIZE(h1), h, SIZE(h), h2, SIZE(h2));

          Assign(cp^.ipnum, h);
          Assign(cp^.port, h2);
          h1:="T:connect to: "; Append(h1, h); Append(h1, " "); Append(h1, h2);
          logline(1, h1);
        END;

        Assign(h,"# ");
        Append(h, VERS);
        Append(h, ""+CR+LF);
        Sendtcp(cp, h);
      END;
    END;

  END;
END tcpconn;

PROCEDURE Serverconn(VAR cp:pTCPSOCK);
VAR t:TIME;
    fd:INTEGER;
    i, oldest:CARDINAL;
    h:FRAMEBUF;
BEGIN
  IF Watchclock(connecttime, 30) THEN
    t:=systime;
    oldest:=0;
    FOR i:=0 TO HIGH(gateways) DO
      WITH gateways[i] DO
        IF (url[0]<>0C) & (lasttry<t) THEN oldest:=i; t:=lasttry END;  
      END;
    END;

    WITH gateways[oldest] DO
      IF url[0]<>0C THEN
        lasttry:=systime;
        fd:=tcp.connectto(url, port);
        IF fd>=0 THEN 
          tcpconn(cp, fd, cISGATEWAY);
          IF cp<>NIL THEN 
            Assign(cp^.ipnum, url);
            Assign(cp^.port, port);
            h:="T:connect to: "; Append(h, url); Append(h, " "); Append(h, port);
            logline(1, h);
          END;
        END;
      END;
    END;
  END;
END Serverconn;

PROCEDURE saybusy(VAR fd:INTEGER; s:ARRAY OF CHAR);
VAR res:INTEGER;
BEGIN
  res:=tcp.sendsock(fd, s, Length(s));
  Close(fd);
  fd:=-1;
END saybusy;

VAR maxsock, listensock,
    wwwsock               : INTEGER;
    mbuf                  : FRAMEBUF;
    res, i                : INTEGER;
    rset, wset            : FdSet;
    acttcp, acttmp        : pTCPSOCK;
    tv                    : TimeVal;
    gatepath              : ARRAY[0..31] OF CHAR;
    usercnt               : CARDINAL; 
    poscall               : POSCALL;
    rfhered               : BOOLEAN;

PROCEDURE addsock(fd:INTEGER; wtoo:BOOLEAN);                (* insert socket in fdset for select *)
BEGIN
  IF fd>=0 THEN
    FD_SET(fd, rset);
    IF wtoo THEN FD_SET(fd, wset) END;
    IF fd>maxsock THEN maxsock:=fd END;
  END;
END addsock;



BEGIN
  Gencrctab;
  FILL(ADR(gateways), 0C, SIZE(gateways));
  FILL(ADR(udpsock), 0C, SIZE(udpsock));
  ungate[0]:="NOGATE";
  ungate[1]:="RFONLY";
  ungate[2]:="TCPIP";
  ungate[3]:="TCPXX";
  ungate[4]:="q";
  ungate[5][0]:=0C;
  connecttime:=0;
  dupetime:=60;
  netbeaconfn[0]:=0C;
  maxusers:=20;
  logframename[0]:=0C;
  logframes:=6;  
  tcpbindport[0]:=0C;
  servercall[0]:=0C; 
  passwd[0]:=0C;
  serverrangefilter[0]:=0C;
  rfhered:=FALSE;
  udpsock.fd:=-1;
  parms;
  gatepath:=",qAU,";
  Append(gatepath, servercall);
  systime:=time(); 
  uptime:=systime;


  Netbeacon(mbuf);
  i:=0; WHILE (i<HIGH(mbuf)-1) & (mbuf[i]<>":") DO INC(i) END; 
  IF show THEN IO.WrLn; IO.WrStrLn(mbuf) END;;
  GetPos(home, mbuf, 0, i+1);                                       (* find server position *) 
  
  IF udpsock.fd>=0 THEN res:=udp.socknonblock(udpsock.fd) END;
  listensock:=-1;
  wwwsock:=-1;
  tcpsocks:=NIL;

  LOOP
    systime:=time();
    IF (listensock<0) & (tcpbindport[0]<>0C) THEN            (* open listensocket tcp connects *)
      listensock:=tcp.waitconnect(tcpbindport,4);
      IF show & (listensock<0) THEN IO.WrStr("cant bind to port "); IO.WrStrLn(tcpbindport) END;  
    END;
    IF (wwwsock<0) & (wwwbindport[0]<>0C) THEN               (* open listensocket www connects *)
      wwwsock:=tcp.waitconnect(wwwbindport,4);
      IF show & (wwwsock<0) THEN IO.WrStr("cant bind to port "); IO.WrStrLn(wwwbindport) END;
    END;


    FD_ZERO(wset);
    FD_ZERO(rset);
    maxsock:=0;

    addsock(udpsock.fd, FALSE);
    addsock(listensock, FALSE);
    addsock(wwwsock, FALSE);

    IF keepconn THEN rfhered:=TRUE END;
    usercnt:=0;
    acttcp:=tcpsocks;                                               (* look if server connect ok *)
    WHILE acttcp<>NIL DO
      WITH acttcp^ DO
        IF beacont<systime THEN Timebeacon(acttcp) END;
        IF service=cISGATEWAY THEN rfhered:=FALSE;
        ELSIF service=cISWWW THEN
          IF connt=0 THEN connt:=systime
          ELSIF connt+HTTPTIMEOUT<systime THEN saybusy(fd, "timeout") END;
        END;
        addsock(fd, tlen>0);
        INC(usercnt);
        acttcp:=next;
      END; 
    END;
    IF rfhered THEN Serverconn(tcpsocks) END;



    mbuf[0]:=0C;
    tv.tv_usec:=0;
    tv.tv_sec:=2;
    res:=select(maxsock+1, ADR(rset), ADR(wset), NIL, ADR(tv));

    IF (listensock>=0) & FD_ISSET(listensock, rset) THEN
      res:=SIZE(mbuf);
      res:=tcp.acceptconnect(listensock, mbuf, res);
      IF res>=0 THEN 
        IF usercnt<maxusers THEN tcpconn(tcpsocks, res, cISSERVER) 
        ELSE saybusy(res, "# server full"+CR+LF) END;
      END;
    END;

    IF (wwwsock>=0) & FD_ISSET(wwwsock, rset) THEN
      res:=SIZE(mbuf);
      res:=tcp.acceptconnect(wwwsock, mbuf, res);
      IF res>=0 THEN
        IF usercnt<maxusers THEN tcpconn(tcpsocks, res, cISWWW) 
        ELSE saybusy(res, "server full") END;
      END;
    END;

    IF (udpsock.fd>=0) & FD_ISSET(udpsock.fd, rset) THEN
      getudp(udpsock.fd, mbuf, udpsock.fromip, udpsock.rawread);
      res:=AprsIs(mbuf,gatepath,5,poscall);
      IF res>=0 THEN
        Sendall(mbuf, udpsock.fd, poscall); 
        rfhered:=TRUE;
      END;
      IF show OR (logframes>1) THEN showframe(res, NIL, mbuf, poscall.pos) END;
    END;

    acttcp:=tcpsocks;
    WHILE acttcp<>NIL DO  
      IF acttcp^.fd>=0 THEN

        IF FD_ISSET(acttcp^.fd, wset) THEN
          WITH acttcp^ DO
            res:=tcp.sendsock(fd, tbuf, tlen);
            IF res>0 THEN
              FOR i:=res TO tlen-1 DO tbuf[i-res]:=tbuf[i] END;
              DEC(tlen,res); 
              IF connt=0 THEN connt:=systime END;
            ELSE tlen:=0 END;                        (* should not happen *)
          END;
        END;

        IF FD_ISSET(acttcp^.fd, rset) THEN
          LOOP
            res:=Gettcp(acttcp^.fd, mbuf, acttcp^.rbuf, acttcp^.rpos);

            IF res<0 THEN
              Close(acttcp^.fd);
              acttcp^.fd:=-1;
              EXIT
            END;
            IF res<=0 THEN EXIT END;

            INC(acttcp^.rxframes);
            INC(acttcp^.rxbytes, Length(mbuf));

            IF acttcp^.service=cISWWW THEN 
              Www(acttcp, mbuf);
              EXIT  
            ELSIF acttcp^.valid OR (acttcp^.service=cISGATEWAY) OR NOT Auth(mbuf, acttcp) THEN 
              res:=AprsIs(mbuf, 0C, 2, poscall);
              IF posvalid(poscall.pos) & StrCmp(poscall.call, acttcp^.user.call) THEN 
                acttcp^.user.pos:=poscall.pos; 
(*
IO.WrLn; IO.WrStr(poscall.call); IO.WrStr(" is at "); IO.WrFixed(poscall.pos.lat/RAD, 4,10); 
IO.WrFixed(poscall.pos.long/RAD, 4,10);IO.WrLn;
*)
              END;
              IF acttcp^.valid THEN
                IF res>=0 THEN Sendall(mbuf, acttcp^.fd, poscall) END;      
                IF show OR (logframes>1) THEN showframe(res, acttcp, mbuf, poscall.pos) END;
              END;
            END;
          END; 
        END;
        acttcp:=acttcp^.next;
      ELSE
        IF show & (acttcp^.connt<>0) & (acttcp^.service<>cISWWW) THEN showlogout(acttcp) END;

        IF acttcp=tcpsocks THEN tcpsocks:=tcpsocks^.next;
        ELSE
          acttmp:=tcpsocks;
          WHILE acttmp^.next<>acttcp DO acttmp:=acttmp^.next END;
          acttmp^.next:=acttcp^.next;
        END;
        DEALLOCATE(acttcp, SIZE(acttcp^));
        acttcp:=tcpsocks;
      END;  
    END;
  END;
END udpgate.


(*
udp sock open in LOOP
keepalive
kill multi conn
www accesscounter
gate tcp to udp

parm: -c,servercall:call -p,passwd:n -m,maxconn:n -l,log:n:fn -t,tcpport:p 
udp:port:i:p -d,duptime:t -g,gateways:i:p -n,netbeacon:t:fn -f,filt:call

  user OE5DXL-10 pass 20911 vers aprsd 2.2.5-15..
  # javAPRSSrvr 3.14b05..
  # logresp OE5DXL-10 verified, server DB0ANF-JS..
  OM3KII-2>APOT2A,OE6XTR,WIDE2*,qAU,OE5DXL-10:!4809.17NS01705.38E# 11.8V 21C..
  OE5DXL-10>APD225,TCPIP*,qAI,OE5DXL-10:!4815.10N/01302.20E&Gateway(144800Rx>INET)..

T:tx >OE5DXL>APX194,TCPIP*:=/6*H(QhpQ-   XASTIR-Linux..
T:tx >OE5DXL>APX194,TCPIP*:=4815.09N/01302.28E-XASTIR-Linux..

user OE5DXL-1 pass 20911 vers udpgate 0.1 filter r/48.25/-13.03/110.0
user OE5DXL-1 pass 20911 vers udpgate 0.1 filter a/48.25/-9/-90/-16

user OE5DXL-1 pass 20911 vers udpgate 0.1 filter m/19
OE5DXL-1>APD225:!4815.10N/01302.20E&

OM3KII-2>APOT2A:!4809.17NS01705.38E# 11.8V 21C

tcp cr lf, filter: TCPXX TCPIP RFONLY NOGATE  
} auch hier filtern
? delete
no blanks in dup filter filter with innermost sourcecall+ssid, innermost destcall no ssid
./udpgate -v -R 0.0.0.0:2000 -c OE5DXL-10 -p 20911 -n 10:netbeacon.txt -l 6:/tmp/log.txt -t 4712 -g ::fffe:c0a8:11e 22 -g 192.168.0.24 1200 -g dxl30 1201
./udpgate -v -R 0.0.0.0:2000 -t 4712 -s OE5DXL-10 -n 0:netbeacon.txt -g 192.168.0.24 1200 -f "p/OE r/48.12/-13.1/300" -l 6:/tmp/log.txt -g localhost 1200 -w 14501
./udpgate -v -c OE5DXL-11 -g -g 192.168.0.24 1200 -t 4712

$GPRMC,043038,A,5049.556,N,01155.680,E,11.8,222.4,270911,,*23
$GPGGA,070123.573,4806.9409,N,01134.6219,E,1,06,1.5,586.4,M,,,,0000*01
$GPGLL,4806.9409,N,01134.6219,E,..........
U:192.168.1.24:2011:tx >OK1ALF>T9TVLL,OK7ED-2,OK4PZ-2*,WIDE2,qAU,OE5DXL-10:)PRl!dK\>"9w}145,500 MHz **www.skr-motorsport.cz**=..
U:tx >DB7MM-9>APOTC1,WIDE1-1,WIDE2-2,qAU,OE5DXL-10:/200418h/6)H]QhBB>>LG/A=001208 13.5V..
U:tx >OE3ILW-3>APTW01,OE3XKR,OE3XHR,WIDE3*,qAU,OE5DXL-10:_09302332c238s000g000t053r000p000P000h..b10191tU2k..
2011.10.21 16:07:40 U:286>OK2ZO-1>APND0Z,OE3XLR*,CZ3-3,OE5XOR*,qAU,OE5DXL-10:=4912.30NS01639.40E#PHG3530DigiNed Brno-Vinohrady


*)
